import * as logger from 'logger';
import exceptionalError from 'exceptionalhandler';
export { exceptionalError };
import * as sfGenericTypes from './salesforceTypes.js';
export { logger };
import * as orderObject from './sfObjects/order.js';
import * as accountObject from './sfObjects/account.js';
import * as locationObject from './sfObjects/location.js';
import * as returnObject from './sfObjects/return.js';
import * as inventoryObject from './sfObjects/inventory.js';
import * as subObject from './sfObjects/subscription.js';
export declare function writeFile(objectToWrite: sfGenericTypes.writeableTypes): Promise<sfGenericTypes.writeableTypes>;
export declare function getBD2Accounts(filters: accountObject.objConstants.selectionFilters): Promise<accountObject.objConstants.niceBD2Accounts>;
export declare function getBD2Locations(filters: locationObject.objConstants.selectionFilters): Promise<locationObject.objConstants.niceBD2Locations>;
export declare function getBD2Orders(filters: orderObject.objConstants.selectionFilters): Promise<orderObject.objConstants.BD2Orders>;
export declare function getBD2OrdersByStatus(orderStatus: typeof orderObject.objConstants.validBD2OrderLookupStatuses[number], filters: orderObject.objConstants.selectionFilters): Promise<orderObject.objConstants.BD2Orders>;
export declare function getBD2Inventories(filters: inventoryObject.objConstants.selectionFilters): Promise<inventoryObject.objConstants.niceBD2Inventories>;
export declare function getBD2Subs(filters: subObject.objConstants.selectionFilters): Promise<subObject.objConstants.niceSubscriptions>;
export declare function getBD2Returns(filters: returnObject.objConstants.selectionFilters): Promise<returnObject.objConstants.niceBD2Returns>;
export declare function createOrFindLocation(locationObj: locationObject.objConstants.niceBD2Location): Promise<sfGenericTypes.writeableTypes>;
export declare function createNewOrder(orderObj: orderObject.objConstants.BD2Order, orderType: typeof orderObject.objConstants.validCreateOrderDetailsTypes[number], inventorySource: typeof orderObject.objConstants.validCreateOrderDetailsSources[number], shippingService?: typeof orderObject.objConstants.validShippingServices[number], isShopifyOrder?: boolean): Promise<orderObject.objConstants.BD2Order>;
export declare function createSubscription(subObj: subObject.objConstants.niceSubscription): Promise<subObject.objConstants.niceSubscription>;
export declare function createAccount(accountDetails: accountObject.objConstants.newAccountUser): Promise<accountObject.objConstants.niceBD2Account>;
