import * as orderObject from './sfObjects/order.js';
import * as accountObject from './sfObjects/account.js';
import * as locationObject from './sfObjects/location.js';
import * as returnObject from './sfObjects/return.js';
import * as inventoryObject from './sfObjects/inventory.js';
import * as subObject from './sfObjects/subscription.js';
export type selectionFilters = orderObject.objConstants.selectionFilters | accountObject.objConstants.selectionFilters | locationObject.objConstants.selectionFilters | returnObject.objConstants.selectionFilters | inventoryObject.objConstants.selectionFilters | subObject.objConstants.selectionFilters;
export type allDetails = {} | accountObject.objConstants.detailsStructure | locationObject.objConstants.detailsStructure | orderObject.objConstants.detailsStructure | returnObject.objConstants.detailsStructure | inventoryObject.objConstants.detailsStructure | subObject.objConstants.detailsStructure;
export interface niceDataDetails {
    [key: string]: niceDataDetail;
}
export interface niceDataStructure {
    [key: string]: niceDataDetails;
}
interface niceDataDetail {
    readOnly: boolean;
    updateable: boolean;
    mandatory: boolean;
    type: (string | null)[];
    readonly validation: ReadonlyArray<string | null> | null;
}
export type objectTypes = typeof orderObject | typeof accountObject | typeof locationObject | typeof returnObject | typeof inventoryObject | typeof subObject;
export type writeableTypes = accountObject.objConstants.niceBD2Account | orderObject.objConstants.BD2Order | locationObject.objConstants.niceBD2Location | returnObject.objConstants.niceBD2Return | subObject.objConstants.niceSubscription;
export interface genericObj {
    [key: string]: any;
}
export {};
