import * as genericObject from './baseSFObjClass.js';
import * as objConstants from './constants/account.constants.js';
export { objConstants };
import * as returnObj from './return.js';
import * as locationObj from './location.js';
import * as orderObj from './order.js';
import * as inventoryObj from './inventory.js';
import * as subObj from './subscription.js';
declare class Account extends genericObject.generalObject {
    details: objConstants.detailsStructure;
    readonly type: string;
    readonly writeable: boolean;
    readonly idReferenceName: string;
    constructor();
    getLocations(filters: locationObj.objConstants.selectionFilters, roughMatch?: boolean): Promise<locationObj.objConstants.niceBD2Locations>;
    getOrders(filters: orderObj.objConstants.selectionFilters, orderStatus?: typeof orderObj.objConstants.validBD2OrderLookupStatuses[number] | null): Promise<orderObj.objConstants.BD2Orders>;
    getInventory(filters?: inventoryObj.objConstants.selectionFilters): Promise<inventoryObj.objConstants.niceBD2Inventories>;
    getReturns(filters?: returnObj.objConstants.selectionFilters): Promise<returnObj.objConstants.niceBD2Returns>;
    getSubscriptions(filters?: subObj.objConstants.selectionFilters): Promise<subObj.objConstants.niceSubscriptions>;
    createLocation(): locationObj.objConstants.niceBD2Location;
    createSubscription(): subObj.objConstants.niceSubscription;
    getAllSubIds(): Promise<string[]>;
}
export declare function createNew(): Account;
