import * as sfObjects from '../../salesforceTypes.js';
import * as sfOrderObj from '../order.js';
export declare const niceNameId = "id";
export declare const niceNameInventoryName = "inventoryName";
export declare const niceNameAccountId = "accountId";
export declare const niceNameAllowNew = "allowNew";
export declare const niceNameAllowReplacement = "allowReplacement";
export declare const niceNameQtyAvailable = "qtyAvailable";
export declare const niceNameIsInventoryAvailable = "isInventoryAvailable";
export declare const niceNameInventoryType = "inventoryType";
export declare const niceNameShopifyVariant = "shopifyVariantId";
export declare const niceNameQtyLifetimeTotal = "qtyLifetimeTotal";
export declare const niceNameQtyUsed = "qtyUsed";
export declare const niceNameCreated = "created";
export declare const niceNameRslSKU = "rslSKU";
export declare const sfApiNameId = "Id";
export declare const sfApiNameInventoryName = "Name";
export declare const sfApiNameAccountId = "BD2_Account__c";
export declare const sfApiNameAllowNew = "Allow_New__c";
export declare const sfApiNameAllowReplacement = "Allow_Replacement__c";
export declare const sfApiNameQtyAvailable = "Available_Quantity__c";
export declare const sfApiNameIsInventoryAvailable = "Inventory_Available__c";
export declare const sfApiNameInventoryType = "Inventory_Type__c";
export declare const sfApiNameShopifyVariant = "Shopify_SKU__c";
export declare const sfApiNameQtyLifetimeTotal = "Order_Quantity__c";
export declare const sfApiNameQtyUsed = "Quantity_Shipped__c";
export declare const sfApiNameCreated = "CreatedDate";
export declare const sfApiNameRslSKU = "RSL_SKU__c";
declare let apiMapping: any;
export { apiMapping };
export interface sfSchema {
    [sfApiNameId]: string;
    [sfApiNameInventoryName]: string;
    [sfApiNameAccountId]: string;
    [sfApiNameAllowNew]: boolean;
    [sfApiNameAllowReplacement]: boolean;
    [sfApiNameQtyAvailable]: number;
    [sfApiNameIsInventoryAvailable]: boolean;
    [sfApiNameInventoryType]: string;
    [sfApiNameShopifyVariant]: string;
    [sfApiNameQtyLifetimeTotal]: number;
    [sfApiNameQtyUsed]: number;
    [sfApiNameCreated]: string;
    [sfApiNameRslSKU]: string;
}
export declare const apiName = "Bulk_BD2_Order__c";
export declare const inventoryTypeNew = "New";
export declare const inventoryTypeRefurb = "Refurbished";
export declare const inventoryTypeDefault = "Default";
export declare const validInventoryTypes: readonly ["New", "Refurbished", "Default"];
export type niceBD2Inventories = niceBD2Inventory[];
export interface niceBD2Inventory {
    type: string;
    writeable: boolean;
    loadedFromSF: boolean;
    details: detailsStructure;
    loadFromSF: Function;
    getOrders: (filters?: sfOrderObj.objConstants.selectionFilters, orderStatus?: typeof sfOrderObj.objConstants.validBD2OrderLookupStatuses[number] | null) => Promise<sfOrderObj.objConstants.BD2Orders>;
    createSF: Function;
}
export interface detailsStructure {
    id: string;
    inventoryName: string;
    accountId: string;
    inventoryType: typeof validInventoryTypes[number];
    isInventoryAvailable: boolean;
    shopifyVariantId: string | null;
    rslSKU: string | null;
    created: Date;
    permittedUse: {
        allowNew: boolean;
        allowReplacement: boolean;
    };
    qty: {
        qtyLifetimeTotal: number;
        qtyUsed: number;
        qtyAvailable: number;
    };
}
export interface selectionFilters {
    [niceNameId]?: string;
    [niceNameInventoryName]?: string;
    [niceNameAccountId]?: string;
    [niceNameAllowNew]?: boolean;
    [niceNameAllowReplacement]?: boolean;
    [niceNameQtyAvailable]?: string;
    [niceNameIsInventoryAvailable]?: boolean;
    [niceNameInventoryType]?: string;
    [niceNameShopifyVariant]?: string;
    [niceNameQtyLifetimeTotal]?: string;
    [niceNameQtyUsed]?: string;
    [niceNameCreated]?: string;
}
export declare const dataStructure: sfObjects.niceDataStructure;
export declare const targetFields: string[];
export interface inventoriesForAccount {
    accountId: null | string;
    inventories: niceBD2Inventories;
}
