export const countryUSA = "US";
export const countryCanada = "CA";
export const validLocationCountry = [countryUSA, countryCanada, null];
export const provinceMapping = {
    "AL": "AL - Alabama",
    "AK": "AK - Alaska",
    "AZ": "AZ - Arizona",
    "AR": "AR - Arkansas",
    "CA": "CA - California",
    "CO": "CO - Colorado",
    "CT": "CT - Connecticut",
    "DE": "DE - Delaware",
    "DC": "DC - District of Columbia",
    "FL": "FL - Florida",
    "GA": "GA - Georgia",
    "HI": "HI - Hawaii",
    "ID": "ID - Idaho",
    "IL": "IL - Illinois",
    "IN": "IN - Indiana",
    "IA": "IA - Iowa",
    "KS": "KS - Kansas",
    "KY": "KY - Kentucky",
    "LA": "LA - Louisiana",
    "ME": "ME - Maine",
    "MD": "MD - Maryland",
    "MA": "MA - Massachusetts",
    "MI": "MI - Michigan",
    "MN": "MN - Minnesota",
    "MS": "MS - Mississippi",
    "MO": "MO - Missouri",
    "MT": "MT - Montana",
    "NE": "NE - Nebraska",
    "NV": "NV - Nevada",
    "NH": "NH - New Hampshire",
    "NJ": "NJ - New Jersey",
    "NM": "NM - New Mexico",
    "NY": "NY - New York",
    "NC": "NC - North Carolina",
    "ND": "ND - North Dakota",
    "OH": "OH - Ohio",
    "OK": "OK - Oklahoma",
    "OR": "OR - Oregon",
    "PA": "PA - Pennsylvania",
    "RI": "RI - Rhode Island",
    "SC": "SC - South Carolina",
    "SD": "SD - South Dakota",
    "TN": "TN - Tennessee",
    "TX": "TX - Texas",
    "UT": "UT - Utah",
    "VT": "VT - Vermont",
    "VA": "VA - Virginia",
    "WA": "WA - Washington",
    "WV": "WV - West Virginia",
    "WI": "WI - Wisconsin",
    "WY": "WY - Wyoming",
    "AB": "AB - Alberta",
    "BC": "BC - British Columbia",
    "MB": "MB - Manitoba",
    "NB": "NB - New Brunswick",
    "NL": "NL - Newfoundland and Labrador",
    "NT": "NT - Northwest Territories",
    "NS": "NS - Nova Scotia",
    "NU": "NU - Nunavut",
    "ON": "ON - Ontario",
    "PE": "PE - Prince Edward Island",
    "QC": "QC - Quebec",
    "SK": "SK - Saskatchewan",
    "YT": "YT - Yukon",
};
let validProvinces = Object.keys(provinceMapping);
validProvinces.push(null);
export const apiName = "BD2_Location__c";
export const dataStructure = {
    topLevel: {
        id: { readOnly: true, updateable: false, mandatory: false, type: ['string'], validation: null },
        locationName: { readOnly: false, updateable: false, mandatory: true, type: ['string', null], validation: null },
        businessName: { readOnly: false, updateable: true, mandatory: false, type: ['string', null], validation: null },
        accountId: { readOnly: false, updateable: false, mandatory: true, type: ['string'], validation: null },
        email: { readOnly: false, updateable: true, mandatory: false, type: ['string', null], validation: null },
        phone: { readOnly: false, updateable: true, mandatory: false, type: ['string', null], validation: null },
        dealerId: { readOnly: false, updateable: true, mandatory: false, type: ['string', null], validation: null },
    },
    address: {
        receiverName: { readOnly: false, updateable: true, mandatory: false, type: ['string', null], validation: null },
        streetAddress: { readOnly: false, updateable: true, mandatory: false, type: ['string', null], validation: null },
        city: { readOnly: false, updateable: true, mandatory: false, type: ['string', null], validation: null },
        province: { readOnly: false, updateable: true, mandatory: false, type: ['string', null], validation: validProvinces },
        postalCode: { readOnly: false, updateable: true, mandatory: false, type: ['string', null], validation: null },
        country: { readOnly: false, updateable: true, mandatory: false, type: ['string', null], validation: validLocationCountry },
        fullAddress: { readOnly: true, updateable: false, mandatory: false, type: ['string', null], validation: null }
    }
};
export const niceNameId = "id";
export const niceNameAccountId = "accountId";
export const niceNameLocationName = "locationName";
export const niceNameBusinessName = "businessName";
export const niceNameDealerId = "dealerId";
export const niceNameReceiverName = "receiverName";
export const niceNameStreetAddress = "streetAddress";
export const niceNameCity = "city";
export const niceNameProvince = "province";
export const niceNamePostalCode = "postalCode";
export const niceNameCountry = "country";
export const niceNamePhone = "phone";
export const niceNameEmail = "email";
export const niceNameFullAddress = "fullAddress";
export const niceNameCreated = "created";
export const sfApiNameId = 'Id';
export const sfApiNameAccountId = 'BD2_Account__c';
export const sfApiNameLocationName = 'Name';
export const sfApiNameBusinessName = 'Business_Name__c';
export const sfApiNameDealerId = 'Dealer_ID__c';
export const sfApiNameReceiverName = 'Receiver_Name__c';
export const sfApiNameStreetAddress = 'Street_Address__c';
export const sfApiNameCity = 'City__c';
export const sfApiNameProvince = 'Province__c';
export const sfApiNamePostalCode = 'Postal_Code__c';
export const sfApiNameCountry = 'Country__c';
export const sfApiNamePhone = 'Phone_Number__c';
export const sfApiNameEmail = 'Receiver_Email_Address__c';
export const sfApiNameFullAddress = 'Shipping_Address__c';
export const sfApiNameCreated = 'CreatedDate';
let apiMapping = {};
apiMapping[niceNameId] = sfApiNameId;
apiMapping[niceNameAccountId] = sfApiNameAccountId;
apiMapping[niceNameLocationName] = sfApiNameLocationName;
apiMapping[niceNameBusinessName] = sfApiNameBusinessName;
apiMapping[niceNameDealerId] = sfApiNameDealerId;
apiMapping[niceNameReceiverName] = sfApiNameReceiverName;
apiMapping[niceNameStreetAddress] = sfApiNameStreetAddress;
apiMapping[niceNameCity] = sfApiNameCity;
apiMapping[niceNameProvince] = sfApiNameProvince;
apiMapping[niceNamePostalCode] = sfApiNamePostalCode;
apiMapping[niceNameCountry] = sfApiNameCountry;
apiMapping[niceNamePhone] = sfApiNamePhone;
apiMapping[niceNameEmail] = sfApiNameEmail;
apiMapping[niceNameFullAddress] = sfApiNameFullAddress;
apiMapping[niceNameCreated] = sfApiNameCreated;
export { apiMapping };
const excludeLocationFields = [];
export const targetFields = Object.keys(apiMapping).filter((a) => (!excludeLocationFields.includes(a)));
