import * as sfObjects from '../../salesforceTypes.js';
export declare const orderFilterNew = "new";
export declare const orderFilterUnshipped = "unshipped";
export declare const orderFilterShipped = "shipped";
export declare const orderFilterPaused = "paused";
export declare const orderFilterAll = "all";
export declare const validBD2OrderLookupStatuses: readonly ["new", "unshipped", "shipped", "paused", "all"];
export declare const bd2ModelClassic = "Standard";
export declare const validBD2Models: readonly ["Standard"];
export declare const moneyCurrencyUSD = "USD";
export declare const moneyCurrencyCAD = "CAD";
export declare const validMoneyCurrencies: readonly ["USD", "CAD"];
export declare const apiName = "BD2_Order__c";
export declare const shipServiceStandard = "Standard";
export declare const shipServiceExpedited = "Express";
export declare const shipServicePriority = "Priority";
export declare const shipServiceFedEx = "Local FedEx";
export declare const validShippingServices: readonly ["Standard", "Express", "Priority", "Local FedEx", null];
export declare const orderTypeInvoicedOrder = "Order - Invoiced";
export declare const orderTypeShopifyOrder = "Order - Shopify";
export declare const orderTypeBulkOrder = "Order - From Bulk";
export declare const orderTypeReplacement = "Replacement";
export declare const orderTypeBulkReplacement = "Replacement - From Bulk";
export declare const orderTypeSample = "Free Sample";
export declare const orderTypeBulkSample = "Free Sample - From Bulk";
export declare const validBD2OrderTypes: readonly ["Order - Invoiced", "Order - Shopify", "Order - From Bulk", "Replacement", "Replacement - From Bulk", "Free Sample", "Free Sample - From Bulk"];
export declare const createOrderDetailsTypeNew = "new";
export declare const createOrderDetailsTypeReplacement = "replacement";
export declare const createOrderDetailsTypeSample = "sample";
export declare const validCreateOrderDetailsTypes: readonly ["new", "replacement", "sample"];
export declare const createOrderDetailsSourceDefault = "default";
export declare const createOrderDetailsSourceBulk = "bulk";
export declare const validCreateOrderDetailsSources: readonly ["default", "bulk"];
export declare const orderStatusOrdered = "Ordered";
export declare const orderStatusFulfilling = "Fulfilling";
export declare const orderStatusPartiallyShipped = "Partially Shipped";
export declare const orderStatusShipped = "Shipped";
export declare const orderStatusPaused = "Paused";
export declare const orderStatusCancelled = "Cancelled";
export declare const validSFOrderStatuses: readonly ["Ordered", "Fulfilling", "Partially Shipped", "Shipped", "Paused", "Cancelled"];
export declare const invoiceStatusNA = "NA";
export declare const invoiceStatusNotSent = "Not Sent";
export declare const invoiceStatusSent = "Sent";
export declare const invoiceStatusShopify = "Shopify";
export declare const validInvoiceStatuses: readonly ["NA", "Not Sent", "Sent", "Shopify"];
type orderType = typeof validBD2OrderTypes[number];
type moneyCurrency = typeof validMoneyCurrencies[number];
type invoiceStatus = typeof validInvoiceStatuses[number];
type BD2Models = typeof validBD2Models[number];
type shippingServices = typeof validShippingServices[number];
export declare const niceNameId = "id";
export declare const niceNameAccountId = "accountId";
export declare const niceNameLocationId = "locationId";
export declare const niceNameInventoryId = "inventoryId";
export declare const niceNameInternalOrderNumber = "internalOrderNumber";
export declare const niceNameBd2Model = "bd2Model";
export declare const niceNameDealerId = "dealerId";
export declare const niceNameExternalOrderNumber = "externalOrderNumber";
export declare const niceNameFulfillmentDate = "fulfillmentDate";
export declare const niceNameShopifyOrderID = "shopifyOrderID";
export declare const niceNameInvoiceDate = "invoiceDate";
export declare const niceNameInvoiceNumber = "invoiceNumber";
export declare const niceNameInvoiceStatus = "invoiceStatus";
export declare const niceNameMoneyCurrency = "moneyCurrency";
export declare const niceNameMoneyTotal = "moneyTotal";
export declare const niceNameMoneyManualAdjustments = "moneyManualAdjustments";
export declare const niceNameMoneyShipping = "moneyShipping";
export declare const niceNameMoneyTax = "moneyTax";
export declare const niceNameMoneyUnitCost = "moneyUnitCost";
export declare const niceNameNotes = "notes";
export declare const niceNameOrderStatus = "orderStatus";
export declare const niceNameOrderType = "orderType";
export declare const niceNameQtyFulfilled = "qtyFulfilled";
export declare const niceNameQtyRequested = "qtyRequested";
export declare const niceNameShippingDate = "shippingDate";
export declare const niceNameShippingService = "shippingService";
export declare const niceNameShippingTrackingCarrier = "shippingTrackingCarrier";
export declare const niceNameShippingTrackingNumber = "shippingTrackingNumber";
export declare const niceNameCreated = "created";
export declare const niceNameOverrideName = "overrideName";
export declare const niceNameOverrideEmail = "overrideEmail";
export declare const niceNameMoneySubtotal = "moneySubtotal";
export declare const sfApiNameId = "Id";
export declare const sfApiNameAccountId = "accountID__c";
export declare const sfApiNameLocationId = "BD2_Location__c";
export declare const sfApiNameInventoryId = "Special_Inventory_Reference__c";
export declare const sfApiNameInternalOrderNumber = "Name";
export declare const sfApiNameBd2Model = "BD2_Model__c";
export declare const sfApiNameDealerId = "Dealer_ID__c";
export declare const sfApiNameExternalOrderNumber = "Customer_PO__c";
export declare const sfApiNameFulfillmentDate = "Fulfillment_Date__c";
export declare const sfApiNameShopifyOrderID = "Fulfillment_Reference__c";
export declare const sfApiNameInvoiceDate = "Invoice_Date__c";
export declare const sfApiNameInvoiceNumber = "Invoice_Number__c";
export declare const sfApiNameInvoiceStatus = "Invoice_Status__c";
export declare const sfApiNameMoneyCurrency = "Currency__c";
export declare const sfApiNameMoneyTotal = "Invoice_Total__c";
export declare const sfApiNameMoneyManualAdjustments = "Manual_Adjustments__c";
export declare const sfApiNameMoneyShipping = "Shipping__c";
export declare const sfApiNameMoneyTax = "Tax__c";
export declare const sfApiNameMoneyUnitCost = "Unit_Cost__c";
export declare const sfApiNameNotes = "Notes__c";
export declare const sfApiNameOrderStatus = "Order_Status__c";
export declare const sfApiNameOrderType = "Order_Type__c";
export declare const sfApiNameQtyFulfilled = "Quantity_Fulfilled__c";
export declare const sfApiNameQtyRequested = "Quantity_Requested__c";
export declare const sfApiNameShippingDate = "Shipment_Date__c";
export declare const sfApiNameShippingService = "Shipping_Service__c";
export declare const sfApiNameShippingTrackingCarrier = "Tracking_Carrier__c";
export declare const sfApiNameShippingTrackingNumber = "Tracking_Number__c";
export declare const sfApiNameCreated = "CreatedDate";
export declare const sfApiNameOverrideName = "overrideReceiverName__c";
export declare const sfApiNameOverrideEmail = "overrideEmail__c";
export declare const sfApiNameSubtotal = "Subtotal__c";
declare let apiMapping: any;
export { apiMapping };
export interface selectionFilters {
    [niceNameId]?: string;
    [niceNameAccountId]?: string;
    [niceNameLocationId]?: string;
    [niceNameInventoryId]?: string;
    [niceNameInternalOrderNumber]?: string;
    [niceNameBd2Model]?: typeof validBD2Models[number];
    [niceNameDealerId]?: string;
    [niceNameExternalOrderNumber]?: string;
    [niceNameFulfillmentDate]?: string;
    [niceNameShopifyOrderID]?: string;
    [niceNameInvoiceDate]?: string;
    [niceNameInvoiceNumber]?: string;
    [niceNameInvoiceStatus]?: string;
    [niceNameMoneyCurrency]?: typeof validMoneyCurrencies[number];
    [niceNameMoneyTotal]?: number;
    [niceNameMoneyManualAdjustments]?: number;
    [niceNameMoneyShipping]?: number;
    [niceNameMoneyTax]?: number;
    [niceNameMoneyUnitCost]?: number;
    [niceNameNotes]?: string;
    [niceNameOrderStatus]?: typeof validSFOrderStatuses[number] | (typeof validSFOrderStatuses[number])[];
    [niceNameOrderType]?: typeof validBD2OrderTypes[number];
    [niceNameQtyFulfilled]?: number;
    [niceNameQtyRequested]?: number;
    [niceNameShippingDate]?: string;
    [niceNameShippingService]?: typeof validShippingServices[number];
    [niceNameShippingTrackingCarrier]?: string;
    [niceNameShippingTrackingNumber]?: string;
    [niceNameCreated]?: string;
    [niceNameOverrideName]?: string;
    [niceNameOverrideEmail]?: string;
}
export interface sfSchema {
    [sfApiNameId]: string;
    [sfApiNameAccountId]: string;
    [sfApiNameLocationId]: string;
    [sfApiNameInventoryId]: string;
    [sfApiNameInternalOrderNumber]: string;
    [sfApiNameBd2Model]: typeof validBD2Models[number];
    [sfApiNameDealerId]: string;
    [sfApiNameExternalOrderNumber]: string;
    [sfApiNameFulfillmentDate]: string;
    [sfApiNameShopifyOrderID]: string;
    [sfApiNameInvoiceDate]: string;
    [sfApiNameInvoiceNumber]: string;
    [sfApiNameInvoiceStatus]: typeof validSFOrderStatuses[number];
    [sfApiNameMoneyCurrency]: typeof validMoneyCurrencies[number];
    [sfApiNameMoneyTotal]: number | null;
    [sfApiNameMoneyManualAdjustments]: number | null;
    [sfApiNameMoneyShipping]: number | null;
    [sfApiNameMoneyTax]: number | null;
    [sfApiNameMoneyUnitCost]: number | null;
    [sfApiNameNotes]: string;
    [sfApiNameOrderStatus]: string;
    [sfApiNameOrderType]: typeof validBD2OrderTypes[number];
    [sfApiNameQtyFulfilled]: number;
    [sfApiNameQtyRequested]: number;
    [sfApiNameShippingDate]: string;
    [sfApiNameShippingService]: typeof validShippingServices[number];
    [sfApiNameShippingTrackingCarrier]: string;
    [sfApiNameShippingTrackingNumber]: string;
    [sfApiNameCreated]: string;
    [sfApiNameOverrideName]: string;
    [sfApiNameOverrideEmail]: string;
    [sfApiNameSubtotal]: number;
}
export type BD2Orders = BD2Order[];
export interface detailsStructure {
    [niceNameId]: string;
    [niceNameLocationId]: string;
    [niceNameAccountId]: string;
    [niceNameInternalOrderNumber]: string;
    [niceNameExternalOrderNumber]: string;
    orderDetails: {
        [niceNameOrderType]: orderType;
        [niceNameBd2Model]: BD2Models;
        [niceNameDealerId]: string | null;
        [niceNameOverrideName]: string | null;
        [niceNameOverrideEmail]: string | null;
    };
    money: {
        [niceNameMoneyCurrency]: moneyCurrency;
        [niceNameMoneyTotal]: number | null;
        [niceNameMoneyManualAdjustments]: number | null;
        [niceNameMoneyShipping]: number | null;
        [niceNameMoneyTax]: number | null;
        [niceNameMoneyUnitCost]: number | null;
        [niceNameMoneySubtotal]: number | null;
    };
    fulfillment: {
        [niceNameShopifyOrderID]: string | null;
        [niceNameFulfillmentDate]: Date | null;
        [niceNameOrderStatus]: typeof validSFOrderStatuses[number];
        [niceNameQtyFulfilled]: number;
        [niceNameQtyRequested]: number;
        [niceNameShippingDate]: Date | null;
        [niceNameShippingService]: shippingServices;
        [niceNameShippingTrackingCarrier]: string | null;
        [niceNameShippingTrackingNumber]: string | null;
        [niceNameInventoryId]: string | null;
    };
    invoicing: {
        [niceNameInvoiceDate]: Date | null;
        [niceNameInvoiceNumber]: string | null;
        [niceNameInvoiceStatus]: invoiceStatus;
    };
    [niceNameNotes]: string;
}
export declare const dataStructure: sfObjects.niceDataStructure;
export declare const targetFields: string[];
export interface orderForAccount {
    accountId: null | string;
    orders: BD2Orders;
}
export interface orderForLocation {
    locationId: null | string;
    orders: BD2Orders;
}
export interface BD2Order {
    type: string;
    writeable: boolean;
    loadedFromSF: boolean;
    details: detailsStructure;
    loadFromSF: Function;
    createSF: Function;
    pauseOrder: Function;
    resumeOrder: Function;
    cancelOrder: Function;
    addTracking: (trackingDeets: trackingDetails[]) => Promise<boolean>;
    markShipped: (qty: number) => Promise<boolean>;
    markFulfilled: () => Promise<boolean>;
}
export interface createOrderDetails {
    type: typeof validCreateOrderDetailsTypes[number];
    source: typeof validCreateOrderDetailsSources[number];
    notes: string[];
    shopifyOrder: boolean;
    isFromBulk: boolean;
    manualInvoiceStatus: boolean;
    invoiceStatus: typeof validInvoiceStatuses[number];
}
export interface trackingDetails {
    carrier: string;
    trackingNumber: string;
    qty: number;
}
