import * as sfObjects from '../../salesforceTypes.js';
export declare const sfApiNameId = "Id";
export declare const sfApiNameSubName = "Name";
export declare const sfApiNameAccountId = "BD2_Account__c";
export declare const sfApiNameChargeType = "Charge_Type__c";
export declare const sfApiNameCoverageTo = "Invoice_To__c";
export declare const sfApiNameCoverageFrom = "Invoice_From__c";
export declare const sfApiNameCurrency = "Currency__c";
export declare const sfApiNameInvoiceDate = "Invoice_Date__c";
export declare const sfApiNameInvoiceNumber = "Invoice_Number__c";
export declare const sfApiNameManualPriceAdjustment = "Manual_Adjustments__c";
export declare const sfApiNameNotes = "Notes__c";
export declare const sfApiNameIsActive = "isActive__c";
export declare const sfApiNameQty = "Subscription_Quantity__c";
export declare const sfApiNameSchedule = "Subscription_Schedule__c";
export declare const sfApiNameSubType = "Subscription_Type__c";
export declare const sfApiNameTotalCharge = "Invoice_Amount__c";
export declare const sfApiNameShopSubId = "Shopify_Subscription_ID__c";
export declare const sfApiNameSubtotal = "Subtotal__c";
export declare const sfApiNameOrderReference = "Associated_Order__c";
export declare const sfApiNameTax = "Tax__c";
export declare const niceNameId = "id";
export declare const niceNameSubName = "externalId";
export declare const niceNameAccountId = "accountId";
export declare const niceNameChargeType = "chargeType";
export declare const niceNameCoverageTo = "coverageTo";
export declare const niceNameCoverageFrom = "coverageFrom";
export declare const niceNameCurrency = "currency";
export declare const niceNameInvoiceDate = "invoiceDate";
export declare const niceNameInvoiceNumber = "invoiceNumber";
export declare const niceNameManualPriceAdjustment = "priceAdjustment";
export declare const niceNameNotes = "notes";
export declare const niceNameIsActive = "isActive";
export declare const niceNameQty = "qty";
export declare const niceNameSchedule = "schedule";
export declare const niceNameSubType = "subType";
export declare const niceNameTotalCharge = "totalCharge";
export declare const niceNameShopSubId = "shopSubId";
export declare const niceNameSubtotal = "subtotal";
export declare const niceNameOrderReference = "associatedOrder";
export declare const niceNameTax = "tax";
export declare const apiMapping: {
    id: string;
    externalId: string;
    accountId: string;
    chargeType: string;
    coverageTo: string;
    coverageFrom: string;
    currency: string;
    invoiceDate: string;
    invoiceNumber: string;
    priceAdjustment: string;
    notes: string;
    isActive: string;
    qty: string;
    schedule: string;
    subType: string;
    totalCharge: string;
    shopSubId: string;
    subtotal: string;
    associatedOrder: string;
    tax: string;
};
export interface sfSchema {
    [sfApiNameId]: string;
    [sfApiNameSubName]: string;
    [sfApiNameAccountId]: string;
    [sfApiNameChargeType]: string;
    [sfApiNameCoverageTo]: string;
    [sfApiNameCoverageFrom]: string;
    [sfApiNameCurrency]: string;
    [sfApiNameInvoiceDate]: string;
    [sfApiNameInvoiceNumber]: string;
    [sfApiNameManualPriceAdjustment]: number;
    [sfApiNameNotes]: string;
    [sfApiNameIsActive]: boolean;
    [sfApiNameQty]: number;
    [sfApiNameSchedule]: string;
    [sfApiNameSubType]: string;
    [sfApiNameTotalCharge]: number;
    [sfApiNameShopSubId]: number;
    [sfApiNameSubtotal]: number;
    [sfApiNameOrderReference]: string | null;
    [sfApiNameTax]: number;
}
export declare const apiName = "BD2_Subscription__c";
export declare enum chargeTypes {
    shopify = "Shopify",
    invoice = "Invoice",
    bundle360 = "R360"
}
export declare const validChargeTypes: readonly [chargeTypes.shopify, chargeTypes.invoice, chargeTypes.bundle360];
export declare enum currencyTypes {
    cad = "CAD",
    usd = "USD"
}
export declare const validCurrencies: readonly [currencyTypes.cad, currencyTypes.usd];
export declare enum subSchedules {
    monthly = "Monthly",
    quarterly = "Quarterly",
    annual = "Annually"
}
export declare const validSubSchedules: readonly [subSchedules.monthly, subSchedules.quarterly, subSchedules.annual];
export declare enum subTypes {
    scan = "Per Scan",
    roof = "Per Roof",
    scanner = "Per Scanner"
}
export declare const validSubTypes: readonly [subTypes.scan, subTypes.roof, subTypes.scanner];
export type niceSubscriptions = niceSubscription[];
export interface niceSubscription {
    type: string;
    writeable: boolean;
    loadedFromSF: boolean;
    details: detailsStructure;
    loadFromSF: Function;
    createSF: Function;
}
export interface detailsStructure {
    [niceNameId]: string;
    [niceNameSubName]: string;
    [niceNameAccountId]: string;
    [niceNameQty]: number;
    [niceNameSchedule]: subSchedules;
    [niceNameSubType]: subTypes;
    [niceNameShopSubId]: string;
    coverage: {
        [niceNameCoverageTo]: Date;
        [niceNameCoverageFrom]: Date;
        [niceNameIsActive]?: boolean;
    };
    monies: {
        [niceNameChargeType]: chargeTypes;
        [niceNameCurrency]: currencyTypes;
        [niceNameInvoiceDate]: Date;
        [niceNameInvoiceNumber]: string;
        [niceNameManualPriceAdjustment]: number;
        [niceNameTotalCharge]: number;
        [niceNameSubtotal]: number;
        [niceNameTax]: number;
    };
    [niceNameNotes]: string;
    [niceNameOrderReference]: string | null;
}
export interface selectionFilters {
    [niceNameId]?: string;
    [niceNameSubName]?: string;
    [niceNameAccountId]?: string;
    [niceNameChargeType]?: string;
    [niceNameCoverageTo]?: string;
    [niceNameCoverageFrom]?: string;
    [niceNameCurrency]?: string;
    [niceNameInvoiceDate]?: string;
    [niceNameInvoiceNumber]?: string;
    [niceNameManualPriceAdjustment]?: string;
    [niceNameNotes]?: string;
    [niceNameIsActive]?: string;
    [niceNameQty]?: string;
    [niceNameSchedule]?: string;
    [niceNameSubType]?: string;
    [niceNameTotalCharge]?: string;
}
export declare const dataStructure: sfObjects.niceDataStructure;
export declare const targetFields: string[];
export interface subsForAccount {
    accountId: null | string;
    subs: niceSubscriptions;
}
export interface subList {
    attributes: any;
    [sfApiNameInvoiceNumber]: string;
}
