export const sfApiNameId = 'Id';
export const sfApiNameSubName = 'Name';
export const sfApiNameAccountId = 'BD2_Account__c';
export const sfApiNameChargeType = 'Charge_Type__c';
export const sfApiNameCoverageTo = 'Invoice_To__c';
export const sfApiNameCoverageFrom = 'Invoice_From__c';
export const sfApiNameCurrency = 'Currency__c';
export const sfApiNameInvoiceDate = 'Invoice_Date__c';
export const sfApiNameInvoiceNumber = 'Invoice_Number__c';
export const sfApiNameManualPriceAdjustment = 'Manual_Adjustments__c';
export const sfApiNameNotes = 'Notes__c';
export const sfApiNameIsActive = 'isActive__c';
export const sfApiNameQty = 'Subscription_Quantity__c';
export const sfApiNameSchedule = 'Subscription_Schedule__c';
export const sfApiNameSubType = 'Subscription_Type__c';
export const sfApiNameTotalCharge = 'Invoice_Amount__c';
export const sfApiNameShopSubId = 'Shopify_Subscription_ID__c';
export const sfApiNameSubtotal = 'Subtotal__c';
export const sfApiNameOrderReference = 'Associated_Order__c';
export const sfApiNameTax = 'Tax__c';
export const niceNameId = 'id';
export const niceNameSubName = 'externalId';
export const niceNameAccountId = 'accountId';
export const niceNameChargeType = 'chargeType';
export const niceNameCoverageTo = 'coverageTo';
export const niceNameCoverageFrom = 'coverageFrom';
export const niceNameCurrency = 'currency';
export const niceNameInvoiceDate = 'invoiceDate';
export const niceNameInvoiceNumber = 'invoiceNumber';
export const niceNameManualPriceAdjustment = 'priceAdjustment';
export const niceNameNotes = 'notes';
export const niceNameIsActive = 'isActive';
export const niceNameQty = 'qty';
export const niceNameSchedule = 'schedule';
export const niceNameSubType = 'subType';
export const niceNameTotalCharge = 'totalCharge';
export const niceNameShopSubId = 'shopSubId';
export const niceNameSubtotal = 'subtotal';
export const niceNameOrderReference = 'associatedOrder';
export const niceNameTax = 'tax';
export const apiMapping = {
    [niceNameId]: sfApiNameId,
    [niceNameSubName]: sfApiNameSubName,
    [niceNameAccountId]: sfApiNameAccountId,
    [niceNameChargeType]: sfApiNameChargeType,
    [niceNameCoverageTo]: sfApiNameCoverageTo,
    [niceNameCoverageFrom]: sfApiNameCoverageFrom,
    [niceNameCurrency]: sfApiNameCurrency,
    [niceNameInvoiceDate]: sfApiNameInvoiceDate,
    [niceNameInvoiceNumber]: sfApiNameInvoiceNumber,
    [niceNameManualPriceAdjustment]: sfApiNameManualPriceAdjustment,
    [niceNameNotes]: sfApiNameNotes,
    [niceNameIsActive]: sfApiNameIsActive,
    [niceNameQty]: sfApiNameQty,
    [niceNameSchedule]: sfApiNameSchedule,
    [niceNameSubType]: sfApiNameSubType,
    [niceNameTotalCharge]: sfApiNameTotalCharge,
    [niceNameShopSubId]: sfApiNameShopSubId,
    [niceNameSubtotal]: sfApiNameSubtotal,
    [niceNameOrderReference]: sfApiNameOrderReference,
    [niceNameTax]: sfApiNameTax
};
export const apiName = "BD2_Subscription__c";
export var chargeTypes;
(function (chargeTypes) {
    chargeTypes["shopify"] = "Shopify";
    chargeTypes["invoice"] = "Invoice";
    chargeTypes["bundle360"] = "R360";
})(chargeTypes || (chargeTypes = {}));
export const validChargeTypes = [chargeTypes.shopify, chargeTypes.invoice, chargeTypes.bundle360]; // for legacy's sake :( wish I'd done this better originally 
export var currencyTypes;
(function (currencyTypes) {
    currencyTypes["cad"] = "CAD";
    currencyTypes["usd"] = "USD";
})(currencyTypes || (currencyTypes = {}));
export const validCurrencies = [currencyTypes.cad, currencyTypes.usd];
export var subSchedules;
(function (subSchedules) {
    subSchedules["monthly"] = "Monthly";
    subSchedules["quarterly"] = "Quarterly";
    subSchedules["annual"] = "Annually";
})(subSchedules || (subSchedules = {}));
export const validSubSchedules = [subSchedules.monthly, subSchedules.quarterly, subSchedules.annual];
export var subTypes;
(function (subTypes) {
    subTypes["scan"] = "Per Scan";
    subTypes["roof"] = "Per Roof";
    subTypes["scanner"] = "Per Scanner";
})(subTypes || (subTypes = {}));
export const validSubTypes = [subTypes.scan, subTypes.roof, subTypes.scanner];
export const dataStructure = {
    topLevel: {
        [niceNameId]: { readOnly: true, updateable: false, mandatory: false, type: ['string'], validation: null },
        [niceNameSubName]: { readOnly: true, updateable: false, mandatory: false, type: ['string'], validation: null },
        [niceNameAccountId]: { readOnly: false, updateable: false, mandatory: true, type: ['string'], validation: null },
        [niceNameQty]: { readOnly: false, updateable: true, mandatory: true, type: ['number'], validation: null },
        [niceNameSchedule]: { readOnly: false, updateable: true, mandatory: true, type: ['string'], validation: validSubSchedules },
        [niceNameSubType]: { readOnly: false, updateable: true, mandatory: true, type: ['string'], validation: validSubTypes },
        [niceNameNotes]: { readOnly: false, updateable: true, mandatory: false, type: ['string'], validation: null },
        [niceNameShopSubId]: { readOnly: false, updateable: true, mandatory: false, type: ['string'], validation: null },
        [niceNameOrderReference]: { readOnly: false, updateable: true, mandatory: false, type: ['string', null], validation: null }
    },
    coverage: {
        [niceNameCoverageTo]: { readOnly: false, updateable: true, mandatory: true, type: ['date'], validation: null },
        [niceNameCoverageFrom]: { readOnly: false, updateable: true, mandatory: true, type: ['date'], validation: null },
        [niceNameIsActive]: { readOnly: true, updateable: false, mandatory: false, type: ['boolean'], validation: null }
    },
    monies: {
        [niceNameChargeType]: { readOnly: false, updateable: true, mandatory: true, type: ['string'], validation: validChargeTypes },
        [niceNameCurrency]: { readOnly: false, updateable: true, mandatory: true, type: ['string'], validation: validCurrencies },
        [niceNameInvoiceDate]: { readOnly: false, updateable: true, mandatory: true, type: ['date'], validation: null },
        [niceNameInvoiceNumber]: { readOnly: false, updateable: true, mandatory: true, type: ['string'], validation: null },
        [niceNameManualPriceAdjustment]: { readOnly: false, updateable: true, mandatory: true, type: ['number'], validation: null },
        [niceNameTotalCharge]: { readOnly: false, updateable: true, mandatory: true, type: ['number'], validation: null },
        [niceNameSubtotal]: { readOnly: false, updateable: true, mandatory: true, type: ['number'], validation: null },
        [niceNameTax]: { readOnly: false, updateable: true, mandatory: true, type: ['number'], validation: null }
    }
};
const excludeSubFields = [];
export const targetFields = Object.keys(apiMapping).filter((a) => (!excludeSubFields.includes(a)));
