import * as genericObject from './baseSFObjClass.js';
import * as sfMethods from '../salesforce.js';
import * as objConstants from './constants/subscription.constants.js';
export { objConstants };
class Subscription extends genericObject.generalObject {
    constructor() {
        super(objConstants.dataStructure, objConstants.apiMapping);
        this.details = this.createNiceObj({}, objConstants.dataStructure, objConstants.apiMapping);
        this.type = 'subscription';
        this.writeable = true;
        this.idReferenceName = "subId";
    }
    loadFromSF(sfObj) {
        super.loadFromSF(sfObj);
        if (!this.details.notes) {
            this.details.notes = "";
        }
    }
    createSF(update = false) {
        let sfObj = super.createSF(update);
        if (this.details.coverage.coverageFrom >= this.details.coverage.coverageTo) {
            throw new sfMethods.exceptionalError("coverageFrom must be before coverageTo");
        }
        if (sfObj.Invoice_To__c) {
            sfObj.Invoice_To__c = sfObj.Invoice_To__c.split("T")[0];
        }
        if (sfObj.Invoice_From__c) {
            sfObj.Invoice_From__c = sfObj.Invoice_From__c.split("T")[0];
        }
        if (sfObj.Invoice_Date__c) {
            sfObj.Invoice_Date__c = sfObj.Invoice_Date__c.split("T")[0];
        }
        return sfObj;
    }
}
export function createNew() {
    let newSub = new Subscription();
    newSub.details.monies.priceAdjustment = 0;
    newSub.details.monies.invoiceDate = new Date();
    newSub.details.notes = "";
    return newSub;
}
