export declare const getAccountNoMatch: {
    req: {
        url: RegExp;
        code: number;
        body: {
            totalSize: number;
            done: boolean;
            records: never[];
        };
    };
    resp: string;
};
export declare const accountByNameOrIDWithLocations: {
    req: {
        url: RegExp;
        code: number;
        body: {
            totalSize: number;
            done: boolean;
            records: {
                attributes: {
                    type: string;
                    url: string;
                };
                Id: string;
                Name: string;
                Accounting_Contact_Email__c: string;
                Accounting_Contact_Name__c: string;
                Accounting_Contact_Phone__c: null;
                BD_User_ID__c: string;
                Contact_Email__c: string;
                Contact_Name__c: null;
                Contact_Phone__c: null;
                User_Type__c: string;
                CreatedDate: string;
                Shipping_Email__c: string;
                CC_Emails__c: boolean;
                Bundle_SKUs__c: boolean;
                SKUs_to_Bundle__c: null;
                Bulk_Fallback_Permitted__c: boolean;
                Mirror_To_Shopify__c: boolean;
                Shopify_Site__c: string;
                Test_Account__c: boolean;
                Override_Subscriptions__c: boolean;
                Subs_Available__c: number;
            }[];
        };
    };
    resp: {
        id: string;
        accountName: string;
        type: string;
        servicesUserId: string;
        mainContact: {
            contactEmail: string;
            contactName: null;
            contactPhone: null;
        };
        accountingContact: {
            accountingEmail: string;
            accountingName: string;
            accountingPhone: null;
        };
        options: {
            shippingEmail: string;
            ccShipping: boolean;
            isTestAccount: boolean;
            bundleSKUs: boolean;
            skuList: null;
            bulkFallbackPermitted: boolean;
            mirrorToShopify: boolean;
            shopifyInstance: string;
            overrideSubs: boolean;
            subsAvailable: number;
        };
    };
    childLocationResp: {
        id: string;
        locationName: string;
        businessName: string;
        accountId: string;
        email: string;
        phone: string;
        dealerId: string;
        address: {
            receiverName: string;
            streetAddress: string;
            city: string;
            province: string;
            postalCode: string;
            country: string;
            fullAddress: string;
        };
    }[];
};
export declare const accountWithChildOrders: {
    req: {
        url: RegExp;
        code: number;
        body: {
            totalSize: number;
            done: boolean;
            records: {
                attributes: {
                    type: string;
                    url: string;
                };
                Id: string;
                Name: string;
                Accounting_Contact_Email__c: string;
                Accounting_Contact_Name__c: string;
                Accounting_Contact_Phone__c: null;
                BD_User_ID__c: string;
                Contact_Email__c: string;
                Contact_Name__c: null;
                Contact_Phone__c: null;
                User_Type__c: string;
                CreatedDate: string;
                Shipping_Email__c: string;
                CC_Emails__c: boolean;
                Bundle_SKUs__c: boolean;
                SKUs_to_Bundle__c: null;
                Bulk_Fallback_Permitted__c: boolean;
                Test_Account__c: boolean;
                Override_Subscriptions__c: boolean;
                Subs_Available__c: number;
            }[];
        };
    };
    resp: {
        id: string;
        accountId: string;
        locationId: string;
        internalOrderNumber: string;
        externalOrderNumber: string;
        notes: string;
        orderDetails: {
            orderType: string;
            bd2Model: string;
            dealerId: null;
            overrideEmail: null;
            overrideName: null;
        };
        money: {
            moneyCurrency: string;
            moneyTotal: null;
            moneyManualAdjustments: null;
            moneyShipping: null;
            moneyTax: null;
            moneyUnitCost: null;
            moneySubtotal: null;
        };
        fulfillment: {
            shopifyOrderID: null;
            fulfillmentDate: null;
            orderStatus: string;
            qtyFulfilled: number;
            qtyRequested: number;
            shippingDate: null;
            shippingService: null;
            shippingTrackingCarrier: null;
            shippingTrackingNumber: null;
            inventoryId: null;
        };
        invoicing: {
            invoiceDate: null;
            invoiceNumber: null;
            invoiceStatus: string;
        };
    }[];
};
export declare const accountWithoutLocations: {
    req: {
        url: RegExp;
        code: number;
        body: {
            totalSize: number;
            done: boolean;
            records: {
                attributes: {
                    type: string;
                    url: string;
                };
                Id: string;
                Name: string;
                Accounting_Contact_Email__c: string;
                Accounting_Contact_Name__c: string;
                Accounting_Contact_Phone__c: null;
                BD_User_ID__c: string;
                Contact_Email__c: string;
                Contact_Name__c: null;
                Contact_Phone__c: null;
                User_Type__c: string;
                CreatedDate: string;
                Shipping_Email__c: string;
                CC_Emails__c: boolean;
                Bundle_SKUs__c: boolean;
                SKUs_to_Bundle__c: null;
                Bulk_Fallback_Permitted__c: boolean;
                Test_Account__c: boolean;
                Override_Subscriptions__c: boolean;
                Subs_Available__c: number;
            }[];
        };
    };
    resp: null;
};
