export const apiMockCases = {
    tokenAuthFailure: {
        req: {
            url: 'begin:https://fake.my.salesforce.com/services/oauth2/token',
            code: 401,
            body: {
                "error": "invalid_grant",
                "error_description": "authentication failure"
            }
        },
        resp: "Error: invalid_grant - authentication failure"
    },
    missingTokenResp: {
        req: {
            url: 'begin:https://fake.my.salesforce.com/services/oauth2/token',
            code: 200,
            body: {
                instance_url: 'https://fake.my.salesforce.com',
                id: 'https://login.salesforce.com/id/FFFFFFFFFFFFF/ZQQQQQQQQQQZZZZZZ',
                token_type: 'Bearer',
                issued_at: '1685981019835',
                signature: '12321rad-1231!#$asdad='
            }
        },
        resp: "Oauth Response was missing the token object"
    },
    goodTokenReq: {
        req: {
            url: 'begin:https://fake.my.salesforce.com/services/oauth2/token',
            code: 200,
            body: {
                access_token: '9daasccasCWEQqw9WDE14$@#AASDDWW$#$$$asdad909-09-0QQQWED',
                instance_url: 'https://fake.my.salesforce.com',
                id: 'https://login.salesforce.com/id/FFFFFFFFFFFFF/ZZZZZZZZZZZZZZZZZZZZ',
                token_type: 'Bearer',
                issued_at: '1685981019835',
                signature: '12321rad-1231!#$asdad='
            }
        },
        resp: '9daasccasCWEQqw9WDE14$@#AASDDWW$#$$$asdad909-09-0QQQWED'
    },
    newTokenCheck: {
        req: {
            url: 'begin:https://fake.my.salesforce.com/services/oauth2/token',
            code: 200,
            body: {
                access_token: 'fffffffffffqweqeqwaaasdsdqtyga',
                instance_url: 'https://fake.my.salesforce.com',
                id: 'https://login.salesforce.com/id/FFFFFFFFFFFFF/ZZZZZZZZZZZZZZZZZZZZ',
                token_type: 'Bearer',
                issued_at: '1685981019835',
                signature: '12321rad-1231!#$asdad='
            }
        },
        resp: '9daasccasCWEQqw9WDE14$@#AASDDWW$#$$$asdad909-09-0QQQWED'
    }
};
