// (https://fsymbols.com/generators/carty/)
//     ░█████╗░░█████╗░░█████╗░░█████╗░██╗░░░██╗███╗░░██╗████████╗░██████╗
//     ██╔══██╗██╔══██╗██╔══██╗██╔══██╗██║░░░██║████╗░██║╚══██╔══╝██╔════╝
//     ███████║██║░░╚═╝██║░░╚═╝██║░░██║██║░░░██║██╔██╗██║░░░██║░░░╚█████╗░
//     ██╔══██║██║░░██╗██║░░██╗██║░░██║██║░░░██║██║╚████║░░░██║░░░░╚═══██╗
//     ██║░░██║╚█████╔╝╚█████╔╝╚█████╔╝╚██████╔╝██║░╚███║░░░██║░░░██████╔╝
//     ╚═╝░░╚═╝░╚════╝░░╚════╝░░╚════╝░░╚═════╝░╚═╝░░╚══╝░░░╚═╝░░░╚═════╝░
export const accountMatchWithoutDealerId = {
    matchURL: `WHERE City__c LIKE '%Glovertown%' AND Province__c LIKE 'KS%' AND Country__c = 'US' AND Postal_Code__c LIKE '%88432%' AND Street_Address__c LIKE '123%' AND BD2_Account__c = 'Some Business Without DealerID'`.replace(/%/g, "%25").replace(/ /g, "%20").replace(/'/g, "%27"),
    returnBody: {
        "totalSize": 1,
        "done": true,
        "records": [
            {
                "attributes": {
                    "type": "BD2_Location__c",
                    "url": "/services/data/v57.0/sobjects/BD2_Location__c/a0hJA0000004bKFYAY"
                },
                "Id": "locationBeingTestedForUpdating",
                "BD2_Account__c": "Some Business Without DealerID",
                "Name": "Testing updating null fields",
                "Business_Name__c": "Some Business Without DealerID",
                "Dealer_ID__c": null,
                "Receiver_Name__c": "Person Q",
                "Street_Address__c": "123 Street Street",
                "City__c": "Glovertown",
                "Province__c": "KS - Kansas",
                "Postal_Code__c": "88432-1234",
                "Country__c": "US",
                "Phone_Number__c": null,
                "Receiver_Email_Address__c": "thing@sympatico.nf.ca",
                "Shipping_Address__c": null,
                "CreatedDate": "2023-06-02T12:42:51.000+0000"
            }
        ]
    }
};
export const accountMatchWithNameSet = {
    matchURL: `WHERE City__c LIKE '%Glovertown%' AND Province__c LIKE 'KS%' AND Country__c = 'US' AND Postal_Code__c LIKE '%88432%' AND Street_Address__c LIKE '123%' AND BD2_Account__c = 'This Should Fail - Name Already Set'`.replace(/%/g, "%25").replace(/ /g, "%20").replace(/'/g, "%27"),
    returnBody: {
        "totalSize": 1,
        "done": true,
        "records": [
            {
                "attributes": {
                    "type": "BD2_Location__c",
                    "url": "/services/data/v57.0/sobjects/BD2_Location__c/a0hJA0000004bKFYAY"
                },
                "Id": "locationBeingTestedForUpdating",
                "BD2_Account__c": "This Should Fail - Name Already Set",
                "Name": "Testing updating null fields",
                "Business_Name__c": "This Should Fail - Name Already Set",
                "Dealer_ID__c": "theDealerId",
                "Receiver_Name__c": "Person Q",
                "Street_Address__c": "123 Street Street",
                "City__c": "Glovertown",
                "Province__c": "KS - Kansas",
                "Postal_Code__c": "88432-1234",
                "Country__c": "US",
                "Phone_Number__c": null,
                "Receiver_Email_Address__c": "thing@sympatico.nf.ca",
                "Shipping_Address__c": null,
                "CreatedDate": "2023-06-02T12:42:51.000+0000"
            }
        ]
    }
};
export const accountWithNoSKUs = {
    url: /WHERE%20Id%20=%20%27anAccountWithNoSkus%27$/,
    code: 200,
    body: {
        "totalSize": 1,
        "done": true,
        "records": [
            {
                "attributes": {
                    "type": "BD2_Account__c",
                    "url": "/services/data/v57.0/sobjects/BD2_Account__c/a0gJA0000000S5EYAU"
                },
                "Id": "anAccountWithNoSkus",
                "Name": "An account without SKUs",
                "Accounting_Contact_Email__c": "accounting@email.com",
                "Accounting_Contact_Name__c": "Chris Nevin",
                "Accounting_Contact_Phone__c": null,
                "BD_User_ID__c": "1234",
                "Contact_Email__c": "fake@email.com",
                "Contact_Name__c": null,
                "Contact_Phone__c": null,
                "User_Type__c": "BaaS",
                "CreatedDate": "2023-06-02T12:42:32.000+0000",
                "Shipping_Email__c": "shipping@email.com",
                "CC_Emails__c": true,
                "Bundle_SKUs__c": false,
                "SKUs_to_Bundle__c": null,
                "Bulk_Fallback_Permitted__c": false
            }
        ]
    }
};
export const accountWithFallbackPermitted = {
    url: /WHERE%20Id%20=%20%27accountWithFallbackPermitted%27$/,
    code: 200,
    body: {
        "totalSize": 1,
        "done": true,
        "records": [
            {
                "attributes": {
                    "type": "BD2_Account__c",
                    "url": "/services/data/v57.0/sobjects/BD2_Account__c/a0gJA0000000S5EYAU"
                },
                "Id": "accountWithFallbackPermitted",
                "Name": "An account without SKUs",
                "Accounting_Contact_Email__c": "accounting@email.com",
                "Accounting_Contact_Name__c": "Chris Nevin",
                "Accounting_Contact_Phone__c": null,
                "BD_User_ID__c": "1234",
                "Contact_Email__c": "fake@email.com",
                "Contact_Name__c": null,
                "Contact_Phone__c": null,
                "User_Type__c": "BaaS",
                "CreatedDate": "2023-06-02T12:42:32.000+0000",
                "Shipping_Email__c": "shipping@email.com",
                "CC_Emails__c": true,
                "Bundle_SKUs__c": false,
                "SKUs_to_Bundle__c": null,
                "Bulk_Fallback_Permitted__c": true
            }
        ]
    }
};
export const accountWithFallbackDisabled = {
    url: /WHERE%20Id%20=%20%27accountWithFallbackDisabled%27$/,
    code: 200,
    body: {
        "totalSize": 1,
        "done": true,
        "records": [
            {
                "attributes": {
                    "type": "BD2_Account__c",
                    "url": "/services/data/v57.0/sobjects/BD2_Account__c/a0gJA0000000S5EYAU"
                },
                "Id": "accountWithFallbackPermitted",
                "Name": "An account without SKUs",
                "Accounting_Contact_Email__c": "accounting@email.com",
                "Accounting_Contact_Name__c": "Chris Nevin",
                "Accounting_Contact_Phone__c": null,
                "BD_User_ID__c": "1234",
                "Contact_Email__c": "fake@email.com",
                "Contact_Name__c": null,
                "Contact_Phone__c": null,
                "User_Type__c": "BaaS",
                "CreatedDate": "2023-06-02T12:42:32.000+0000",
                "Shipping_Email__c": "shipping@email.com",
                "CC_Emails__c": true,
                "Bundle_SKUs__c": false,
                "SKUs_to_Bundle__c": null,
                "Bulk_Fallback_Permitted__c": false
            }
        ]
    }
};
export const accountWithSKUs = {
    url: /WHERE%20Id%20=%20%27anAccountWithSkus%27$/,
    code: 200,
    body: {
        "totalSize": 1,
        "done": true,
        "records": [
            {
                "attributes": {
                    "type": "BD2_Account__c",
                    "url": "/services/data/v57.0/sobjects/BD2_Account__c/a0gJA0000000S5EYAU"
                },
                "Id": "anAccountWithSkus",
                "Name": "An account with SKUs",
                "Accounting_Contact_Email__c": "accounting@email.com",
                "Accounting_Contact_Name__c": "Chris Nevin",
                "Accounting_Contact_Phone__c": null,
                "BD_User_ID__c": "1234",
                "Contact_Email__c": "fake@email.com",
                "Contact_Name__c": null,
                "Contact_Phone__c": null,
                "User_Type__c": "BaaS",
                "CreatedDate": "2023-06-02T12:42:32.000+0000",
                "Shipping_Email__c": "shipping@email.com",
                "CC_Emails__c": true,
                "Bundle_SKUs__c": true,
                "SKUs_to_Bundle__c": `SKU1\r\nSKU2\r\nSKU3`,
                "Bulk_Fallback_Permitted__c": false
            }
        ]
    }
};
//    ██╗███╗░░██╗██╗░░░██╗███████╗███╗░░██╗████████╗░█████╗░██████╗░██╗░░░██╗
//    ██║████╗░██║██║░░░██║██╔════╝████╗░██║╚══██╔══╝██╔══██╗██╔══██╗╚██╗░██╔╝
//    ██║██╔██╗██║╚██╗░██╔╝█████╗░░██╔██╗██║░░░██║░░░██║░░██║██████╔╝░╚████╔╝░
//    ██║██║╚████║░╚████╔╝░██╔══╝░░██║╚████║░░░██║░░░██║░░██║██╔══██╗░░╚██╔╝░░
//    ██║██║░╚███║░░╚██╔╝░░███████╗██║░╚███║░░░██║░░░╚█████╔╝██║░░██║░░░██║░░░
//    ╚═╝╚═╝░░╚══╝░░░╚═╝░░░╚══════╝╚═╝░░╚══╝░░░╚═╝░░░░╚════╝░╚═╝░░╚═╝░░░╚═╝░░░
export const inventoryMatchesAndPermitsNew = {
    url: /inventoryWithPermittedNewAndQtyAvail%27$/i,
    code: 200,
    body: {
        "totalSize": 1,
        "done": true,
        "records": [
            {
                "attributes": {
                    "type": "Bulk_BD2_Order__c",
                    "url": "/services/data/v57.0/sobjects/Bulk_BD2_Order__c/a0fJA000000QuDMYA0"
                },
                "Id": "inventoryWithPermittedNewAndQtyAvail",
                "Name": "aResultByName",
                "BD2_Account__c": "a0gJA0000000SvBYAU",
                "Allow_New__c": true,
                "Allow_Replacement__c": true,
                "Available_Quantity__c": 1000.0,
                "Inventory_Available__c": true,
                "Inventory_Type__c": "New",
                "Shopify_SKU__c": "12345",
                "Order_Quantity__c": 1000.0,
                "Quantity_Shipped__c": null,
                "CreatedDate": "2023-06-15T13:00:26.000+0000"
            },
        ]
    }
};
export const inventoryMatchesInsufficientQty = {
    url: /inventoryMatchesInsufficientQty%27$/i,
    code: 200,
    body: {
        "totalSize": 1,
        "done": true,
        "records": [
            {
                "attributes": {
                    "type": "Bulk_BD2_Order__c",
                    "url": "/services/data/v57.0/sobjects/Bulk_BD2_Order__c/a0fJA000000QuDMYA0"
                },
                "Id": "inventoryMatchesInsufficientQty",
                "Name": "aResultByName",
                "BD2_Account__c": "a0gJA0000000SvBYAU",
                "Allow_New__c": true,
                "Allow_Replacement__c": true,
                "Available_Quantity__c": 1.0,
                "Inventory_Available__c": true,
                "Inventory_Type__c": "New",
                "Shopify_SKU__c": "12345",
                "Order_Quantity__c": 1000.0,
                "Quantity_Shipped__c": null,
                "CreatedDate": "2023-06-15T13:00:26.000+0000"
            },
        ]
    }
};
export const inventoryReplacementOnly = {
    url: /inventoryReplacementOnly%27$|WHERE%20BD2_Account__c%20=%20%27accountWithFallbackDisabled%27%20AND%20Available_Quantity__c%20%3E=%2025%20AND%20Allow_Replacement__c%20=%20true/i,
    code: 200,
    body: {
        "totalSize": 1,
        "done": true,
        "records": [
            {
                "attributes": {
                    "type": "Bulk_BD2_Order__c",
                    "url": "/services/data/v57.0/sobjects/Bulk_BD2_Order__c/a0fJA000000QuDMYA0"
                },
                "Id": "inventoryReplacementOnly",
                "Name": "aResultByName",
                "BD2_Account__c": "a0gJA0000000SvBYAU",
                "Allow_New__c": false,
                "Allow_Replacement__c": true,
                "Available_Quantity__c": 100.0,
                "Inventory_Available__c": true,
                "Inventory_Type__c": "New",
                "Shopify_SKU__c": null,
                "Order_Quantity__c": 1000.0,
                "Quantity_Shipped__c": null,
                "CreatedDate": "2023-06-15T13:00:26.000+0000"
            },
        ]
    }
};
export const fallBackInventoryNoMatch = {
    url: /Available_Quantity__c%20%3E=%205%20AND%20Allow_New__c%20=%20true$/i,
    code: 200,
    body: {
        "totalSize": 0,
        "done": true,
        "records": []
    }
};
export const fallBackInventoryReplacementNoMatch = {
    url: /Available_Quantity__c%20%3E=%205%20AND%20Allow_Replacement__c%20=%20true$/i,
    code: 200,
    body: {
        "totalSize": 0,
        "done": true,
        "records": []
    }
};
export const fallBackInventoryWithMatchWithoutExtSKU = {
    url: /Available_Quantity__c%20%3E=%2025%20AND%20Allow_New__c%20=%20true$/i,
    code: 200,
    body: {
        "totalSize": 1,
        "done": true,
        "records": [
            {
                "attributes": {
                    "type": "Bulk_BD2_Order__c",
                    "url": "/services/data/v57.0/sobjects/Bulk_BD2_Order__c/a0fJA000000QuDMYA0"
                },
                "Id": "aGoodFallbackInventory",
                "Name": "aResultByName",
                "BD2_Account__c": "a0gJA0000000SvBYAU",
                "Allow_New__c": true,
                "Allow_Replacement__c": false,
                "Available_Quantity__c": 100.0,
                "Inventory_Available__c": true,
                "Inventory_Type__c": "New",
                "Shopify_SKU__c": null,
                "Order_Quantity__c": 1000.0,
                "Quantity_Shipped__c": null,
                "CreatedDate": "2023-06-15T13:00:26.000+0000"
            }
        ]
    }
};
//    ░█████╗░██████╗░██████╗░███████╗██████╗░░██████╗
//    ██╔══██╗██╔══██╗██╔══██╗██╔════╝██╔══██╗██╔════╝
//    ██║░░██║██████╔╝██║░░██║█████╗░░██████╔╝╚█████╗░
//    ██║░░██║██╔══██╗██║░░██║██╔══╝░░██╔══██╗░╚═══██╗
//    ╚█████╔╝██║░░██║██████╔╝███████╗██║░░██║██████╔╝
//    ░╚════╝░╚═╝░░╚═╝╚═════╝░╚══════╝╚═╝░░╚═╝╚═════╝░
export const anOrderToUpdate = {
    url: /Id%20=%20%27anOrderToUpdate%27/i,
    code: 200,
    body: {
        "totalSize": 1,
        "done": true,
        "records": [
            {
                "attributes": {
                    "type": "BD2_Order__c",
                    "url": "/services/data/v57.0/sobjects/BD2_Order__c/a0jJA0000002N3BYAU"
                },
                "Id": "anOrderToUpdate",
                'accountID__c': 'someAccount',
                "BD2_Location__c": "someLocation",
                "Name": "anOrderToUpdate",
                "Customer_PO__c": "someExternalPO",
                "Order_Type__c": "Free Sample",
                "BD2_Model__c": "Standard",
                "Dealer_ID__c": null,
                "Currency__c": "CAD",
                "Invoice_Total__c": null,
                "Manual_Adjustments__c": null,
                "Shipping__c": null,
                "Tax__c": null,
                "Unit_Cost__c": null,
                "Fulfillment_Reference__c": null,
                "Fulfillment_Date__c": null,
                "Order_Status__c": "Ordered",
                "Quantity_Fulfilled__c": 0,
                "Quantity_Requested__c": 10,
                "Shipment_Date__c": null,
                "Shipping_Service__c": "Standard",
                "Tracking_Carrier__c": null,
                "Tracking_Number__c": null,
                "Special_Inventory_Reference__c": null,
                "Invoice_Date__c": null,
                "Invoice_Number__c": null,
                "Invoice_Status__c": "NA",
                'Notes__c': ""
            }
        ]
    }
};
export function checkOrderPatch(url, opts) {
    let body = JSON.parse(opts.body);
    let status = body.Order_Status__c;
    if (!["Paused", "Ordered", "Shipped", "Cancelled", "Fulfilling", "Partially Shipped"].includes(status)) {
        throw `Invalid test patch status ${status}`;
    }
    return {
        status: 201,
        body: {
            "id": "someId",
            "success": true,
            "errors": []
        }
    };
}
//    ░██╗░░░░░░░██╗██████╗░██╗████████╗███████╗░██████╗
//    ░██║░░██╗░░██║██╔══██╗██║╚══██╔══╝██╔════╝██╔════╝
//    ░╚██╗████╗██╔╝██████╔╝██║░░░██║░░░█████╗░░╚█████╗░
//    ░░████╔═████║░██╔══██╗██║░░░██║░░░██╔══╝░░░╚═══██╗
//    ░░╚██╔╝░╚██╔╝░██║░░██║██║░░░██║░░░███████╗██████╔╝
//    ░░░╚═╝░░░╚═╝░░╚═╝░░╚═╝╚═╝░░░╚═╝░░░╚══════╝╚═════╝░
export function checkWriteBody(url, opts) {
    let body = JSON.parse(opts.body);
    let respObj = { body: null, code: 400 };
    let expectedBody = {};
    if (opts.headers['Content-Type'] !== 'application/json') {
        throw `Any post/patch gotta be application/json`;
    }
    // POST/CREATE
    if (opts.method === "POST") {
        if (url.match(/location__c/i)) {
            if (body.Name === 'Blah blah blah') {
                expectedBody = JSON.stringify({
                    Name: 'Blah blah blah',
                    Business_Name__c: null,
                    BD2_Account__c: 'nopeSheDontExist',
                    Receiver_Email_Address__c: null,
                    Phone_Number__c: null,
                    Dealer_ID__c: null,
                    Receiver_Name__c: null,
                    Street_Address__c: '180 Street Place',
                    City__c: 'Mount Cityburg',
                    Province__c: 'CT - Connecticut',
                    Postal_Code__c: 'A0A 3F3',
                    Country__c: 'CA'
                });
                respObj = createSuccess;
            }
            else if (body.Name === "Testing updating null fields") {
                throw `This should never happen! Tried to post ${body.Name}`;
            }
        }
        else if (url.match(/order__c/i)) {
            switch (body.Customer_PO__c) {
                case "aSuccessfulNewBulkOrder1":
                    expectedBody = JSON.stringify({ "BD2_Location__c": "locationOne", "Customer_PO__c": "aSuccessfulNewBulkOrder1", "Notes__c": null, "Order_Type__c": "Order - From Bulk", "BD2_Model__c": "Standard", "Dealer_ID__c": null, "overrideReceiverName__c": null, "overrideEmail__c": null, "Currency__c": "USD", "Invoice_Total__c": null, "Manual_Adjustments__c": null, "Shipping__c": null, "Tax__c": null, "Unit_Cost__c": null, "Fulfillment_Reference__c": null, "Fulfillment_Date__c": null, "Order_Status__c": "Ordered", "Quantity_Fulfilled__c": 0, "Quantity_Requested__c": 5, "Shipment_Date__c": null, "Shipping_Service__c": "Standard", "Tracking_Carrier__c": null, "Tracking_Number__c": null, "Special_Inventory_Reference__c": "inventoryWithPermittedNewAndQtyAvail", "Invoice_Date__c": null, "Invoice_Number__c": null, "Invoice_Status__c": "NA" });
                    respObj = {
                        code: 201,
                        body: {
                            "id": "aNewBulkOrder1Created",
                            "success": true,
                            "errors": []
                        }
                    };
                    break;
                case "bulkShopifyOrder":
                    expectedBody = JSON.stringify({
                        BD2_Location__c: 'someLocation',
                        Customer_PO__c: 'bulkShopifyOrder',
                        Notes__c: null,
                        Order_Type__c: 'Order - From Bulk',
                        BD2_Model__c: 'Standard',
                        Dealer_ID__c: null,
                        overrideReceiverName__c: null,
                        overrideEmail__c: null,
                        Currency__c: 'USD',
                        Invoice_Total__c: null,
                        Manual_Adjustments__c: null,
                        Shipping__c: null,
                        Tax__c: null,
                        Unit_Cost__c: null,
                        Fulfillment_Reference__c: null,
                        Fulfillment_Date__c: null,
                        Order_Status__c: 'Ordered',
                        Quantity_Fulfilled__c: 0,
                        Quantity_Requested__c: 5,
                        Shipment_Date__c: null,
                        Shipping_Service__c: 'Standard',
                        Tracking_Carrier__c: null,
                        Tracking_Number__c: null,
                        Special_Inventory_Reference__c: "inventoryWithPermittedNewAndQtyAvail",
                        Invoice_Date__c: null,
                        Invoice_Number__c: null,
                        Invoice_Status__c: 'NA'
                    });
                    respObj = {
                        code: 201,
                        body: {
                            "id": "shopifyBulkedOrder",
                            "success": true,
                            "errors": []
                        }
                    };
                    break;
                case "aNewBulkFallbackOrder":
                    expectedBody = JSON.stringify({
                        BD2_Location__c: 'locationTwo',
                        Customer_PO__c: 'aNewBulkFallbackOrder',
                        Notes__c: "Order specified bulk inventory inventoryMatchesInsufficientQty which was not available or valid",
                        Order_Type__c: 'Order - Invoiced',
                        BD2_Model__c: 'Standard',
                        Dealer_ID__c: null,
                        overrideReceiverName__c: null,
                        overrideEmail__c: null,
                        Currency__c: 'USD',
                        Invoice_Total__c: null,
                        Manual_Adjustments__c: null,
                        Shipping__c: null,
                        Tax__c: null,
                        Unit_Cost__c: null,
                        Fulfillment_Reference__c: null,
                        Fulfillment_Date__c: null,
                        Order_Status__c: 'Ordered',
                        Quantity_Fulfilled__c: 0,
                        Quantity_Requested__c: 5,
                        Shipment_Date__c: null,
                        Shipping_Service__c: 'Standard',
                        Tracking_Carrier__c: null,
                        Tracking_Number__c: null,
                        Special_Inventory_Reference__c: null,
                        Invoice_Date__c: null,
                        Invoice_Number__c: null,
                        Invoice_Status__c: 'Not Sent'
                    });
                    respObj = {
                        code: 201,
                        body: {
                            "id": "aNewBulkOrder2Created",
                            "success": true,
                            "errors": []
                        }
                    };
                    break;
                case "aFallbackOrderDueToPermissionRestrictions":
                    expectedBody = JSON.stringify({
                        BD2_Location__c: 'locationThree',
                        Customer_PO__c: 'aFallbackOrderDueToPermissionRestrictions',
                        Notes__c: "Order specified bulk inventory inventoryReplacementOnly which was not available or valid\nAssigned order to inventory ID aGoodFallbackInventory",
                        Order_Type__c: 'Order - From Bulk',
                        BD2_Model__c: 'Standard',
                        Dealer_ID__c: null,
                        overrideReceiverName__c: null,
                        overrideEmail__c: null,
                        Currency__c: 'USD',
                        Invoice_Total__c: null,
                        Manual_Adjustments__c: null,
                        Shipping__c: null,
                        Tax__c: null,
                        Unit_Cost__c: null,
                        Fulfillment_Reference__c: null,
                        Fulfillment_Date__c: null,
                        Order_Status__c: 'Ordered',
                        Quantity_Fulfilled__c: 0,
                        Quantity_Requested__c: 25,
                        Shipment_Date__c: null,
                        Shipping_Service__c: 'Local FedEx',
                        Tracking_Carrier__c: null,
                        Tracking_Number__c: null,
                        Special_Inventory_Reference__c: "aGoodFallbackInventory",
                        Invoice_Date__c: null,
                        Invoice_Number__c: null,
                        Invoice_Status__c: 'NA'
                    });
                    respObj = {
                        code: 201,
                        body: {
                            "id": "aNewBulkOrder3Created",
                            "success": true,
                            "errors": []
                        }
                    };
                    break;
                case "anOrderWithoutInventoryIdSpecified":
                    expectedBody = JSON.stringify({
                        BD2_Location__c: 'locationFour',
                        Customer_PO__c: 'anOrderWithoutInventoryIdSpecified',
                        Notes__c: "Assigned order to inventory ID aGoodFallbackInventory",
                        Order_Type__c: 'Order - From Bulk',
                        BD2_Model__c: 'Standard',
                        Dealer_ID__c: null,
                        overrideReceiverName__c: null,
                        overrideEmail__c: null,
                        Currency__c: 'USD',
                        Invoice_Total__c: null,
                        Manual_Adjustments__c: null,
                        Shipping__c: null,
                        Tax__c: null,
                        Unit_Cost__c: null,
                        Fulfillment_Reference__c: null,
                        Fulfillment_Date__c: null,
                        Order_Status__c: 'Ordered',
                        Quantity_Fulfilled__c: 0,
                        Quantity_Requested__c: 25,
                        Shipment_Date__c: null,
                        Shipping_Service__c: 'Local FedEx',
                        Tracking_Carrier__c: null,
                        Tracking_Number__c: null,
                        Special_Inventory_Reference__c: "aGoodFallbackInventory",
                        Invoice_Date__c: null,
                        Invoice_Number__c: null,
                        Invoice_Status__c: 'NA'
                    });
                    respObj = {
                        code: 201,
                        body: {
                            "id": "aNewBulkOrder4Created",
                            "success": true,
                            "errors": []
                        }
                    };
                    break;
                case "anOrderWithoutInvIdRSLFallback":
                    expectedBody = JSON.stringify({
                        BD2_Location__c: 'locationFive',
                        Customer_PO__c: 'anOrderWithoutInvIdRSLFallback',
                        Notes__c: "Original request was bulk with no target inventory set - fallback to RSL",
                        Order_Type__c: 'Order - Invoiced',
                        BD2_Model__c: 'Standard',
                        Dealer_ID__c: null,
                        overrideReceiverName__c: null,
                        overrideEmail__c: null,
                        Currency__c: 'USD',
                        Invoice_Total__c: null,
                        Manual_Adjustments__c: null,
                        Shipping__c: null,
                        Tax__c: null,
                        Unit_Cost__c: null,
                        Fulfillment_Reference__c: null,
                        Fulfillment_Date__c: null,
                        Order_Status__c: 'Ordered',
                        Quantity_Fulfilled__c: 0,
                        Quantity_Requested__c: 5,
                        Shipment_Date__c: null,
                        Shipping_Service__c: 'Express',
                        Tracking_Carrier__c: null,
                        Tracking_Number__c: null,
                        Special_Inventory_Reference__c: null,
                        Invoice_Date__c: null,
                        Invoice_Number__c: null,
                        Invoice_Status__c: 'Not Sent'
                    });
                    respObj = {
                        code: 201,
                        body: {
                            "id": "aNewBulkOrder5Created",
                            "success": true,
                            "errors": []
                        }
                    };
                    break;
                case "aReplacementWithoutSourceAutoSelect":
                    expectedBody = JSON.stringify({
                        BD2_Location__c: 'locationSix',
                        Customer_PO__c: 'aReplacementWithoutSourceAutoSelect',
                        Notes__c: "Assigned order to inventory ID inventoryReplacementOnly",
                        Order_Type__c: 'Replacement - From Bulk',
                        BD2_Model__c: 'Standard',
                        Dealer_ID__c: null,
                        overrideReceiverName__c: null,
                        overrideEmail__c: null,
                        Currency__c: 'USD',
                        Invoice_Total__c: null,
                        Manual_Adjustments__c: null,
                        Shipping__c: null,
                        Tax__c: null,
                        Unit_Cost__c: null,
                        Fulfillment_Reference__c: null,
                        Fulfillment_Date__c: null,
                        Order_Status__c: 'Ordered',
                        Quantity_Fulfilled__c: 0,
                        Quantity_Requested__c: 25,
                        Shipment_Date__c: null,
                        Shipping_Service__c: 'Local FedEx',
                        Tracking_Carrier__c: null,
                        Tracking_Number__c: null,
                        Special_Inventory_Reference__c: "inventoryReplacementOnly",
                        Invoice_Date__c: null,
                        Invoice_Number__c: null,
                        Invoice_Status__c: 'NA'
                    });
                    respObj = {
                        code: 201,
                        body: {
                            "id": "aNewBulkReplacement1Created",
                            "success": true,
                            "errors": []
                        }
                    };
                    break;
                case "aReplacementWithoutSourceNoFBAvailable":
                    expectedBody = JSON.stringify({
                        BD2_Location__c: 'locationSeven',
                        Customer_PO__c: 'aReplacementWithoutSourceNoFBAvailable',
                        Notes__c: "Original request was bulk with no target inventory set - fallback to RSL",
                        Order_Type__c: 'Replacement',
                        BD2_Model__c: 'Standard',
                        Dealer_ID__c: null,
                        overrideReceiverName__c: null,
                        overrideEmail__c: null,
                        Currency__c: 'USD',
                        Invoice_Total__c: null,
                        Manual_Adjustments__c: null,
                        Shipping__c: null,
                        Tax__c: null,
                        Unit_Cost__c: null,
                        Fulfillment_Reference__c: null,
                        Fulfillment_Date__c: null,
                        Order_Status__c: 'Ordered',
                        Quantity_Fulfilled__c: 0,
                        Quantity_Requested__c: 5,
                        Shipment_Date__c: null,
                        Shipping_Service__c: 'Standard',
                        Tracking_Carrier__c: null,
                        Tracking_Number__c: null,
                        Special_Inventory_Reference__c: null,
                        Invoice_Date__c: null,
                        Invoice_Number__c: null,
                        Invoice_Status__c: 'NA'
                    });
                    respObj = {
                        code: 201,
                        body: {
                            "id": "aNewBulkReplacement2Created",
                            "success": true,
                            "errors": []
                        }
                    };
                    break;
                case "aReplacementWhatFallsBackToDifferentBulkInventory":
                    expectedBody = JSON.stringify({
                        BD2_Location__c: 'locationEight',
                        Customer_PO__c: 'aReplacementWhatFallsBackToDifferentBulkInventory',
                        Notes__c: `Order specified bulk inventory inventoryMatchesInsufficientQty which was not available or valid\nAssigned order to inventory ID inventoryReplacementOnly`,
                        Order_Type__c: 'Replacement - From Bulk',
                        BD2_Model__c: 'Standard',
                        Dealer_ID__c: null,
                        overrideReceiverName__c: null,
                        overrideEmail__c: null,
                        Currency__c: 'USD',
                        Invoice_Total__c: null,
                        Manual_Adjustments__c: null,
                        Shipping__c: null,
                        Tax__c: null,
                        Unit_Cost__c: null,
                        Fulfillment_Reference__c: null,
                        Fulfillment_Date__c: null,
                        Order_Status__c: 'Ordered',
                        Quantity_Fulfilled__c: 0,
                        Quantity_Requested__c: 25,
                        Shipment_Date__c: null,
                        Shipping_Service__c: 'Local FedEx',
                        Tracking_Carrier__c: null,
                        Tracking_Number__c: null,
                        Special_Inventory_Reference__c: "inventoryReplacementOnly",
                        Invoice_Date__c: null,
                        Invoice_Number__c: null,
                        Invoice_Status__c: 'NA'
                    });
                    respObj = {
                        code: 201,
                        body: {
                            "id": "aNewBulkReplacement3Created",
                            "success": true,
                            "errors": []
                        }
                    };
                    break;
                case "aNewOrderWithoutInvoiceStatus":
                    expectedBody = JSON.stringify({
                        BD2_Location__c: 'someId',
                        Customer_PO__c: 'aNewOrderWithoutInvoiceStatus',
                        Notes__c: null,
                        Order_Type__c: 'Order - Invoiced',
                        BD2_Model__c: 'Standard',
                        Dealer_ID__c: null,
                        overrideReceiverName__c: null,
                        overrideEmail__c: null,
                        Currency__c: 'USD',
                        Invoice_Total__c: 999,
                        Manual_Adjustments__c: -20,
                        Shipping__c: 0,
                        Tax__c: 20,
                        Unit_Cost__c: 333,
                        Fulfillment_Reference__c: null,
                        Fulfillment_Date__c: null,
                        Order_Status__c: 'Ordered',
                        Quantity_Fulfilled__c: 0,
                        Quantity_Requested__c: 3,
                        Shipment_Date__c: null,
                        Shipping_Service__c: 'Local FedEx',
                        Tracking_Carrier__c: null,
                        Tracking_Number__c: null,
                        Special_Inventory_Reference__c: null,
                        Invoice_Date__c: null,
                        Invoice_Number__c: null,
                        Invoice_Status__c: 'Not Sent'
                    });
                    respObj = {
                        code: 201,
                        body: {
                            "id": "goodNewNoInvStatus",
                            "success": true,
                            "errors": []
                        }
                    };
                    break;
                case "aNewOrderWithInvoiceStatus":
                    expectedBody = JSON.stringify({
                        BD2_Location__c: 'someId',
                        Customer_PO__c: 'aNewOrderWithInvoiceStatus',
                        Notes__c: null,
                        Order_Type__c: 'Order - Invoiced',
                        BD2_Model__c: 'Standard',
                        Dealer_ID__c: null,
                        overrideReceiverName__c: null,
                        overrideEmail__c: null,
                        Currency__c: 'USD',
                        Invoice_Total__c: 999,
                        Manual_Adjustments__c: -20,
                        Shipping__c: 0,
                        Tax__c: 20,
                        Unit_Cost__c: 333,
                        Fulfillment_Reference__c: null,
                        Fulfillment_Date__c: null,
                        Order_Status__c: 'Ordered',
                        Quantity_Fulfilled__c: 0,
                        Quantity_Requested__c: 3,
                        Shipment_Date__c: null,
                        Shipping_Service__c: 'Local FedEx',
                        Tracking_Carrier__c: null,
                        Tracking_Number__c: null,
                        Special_Inventory_Reference__c: null,
                        Invoice_Date__c: null,
                        Invoice_Number__c: null,
                        Invoice_Status__c: 'Sent'
                    });
                    respObj = {
                        code: 201,
                        body: {
                            "id": "goodNewInvStatus",
                            "success": true,
                            "errors": []
                        }
                    };
                    break;
                case "aReplacementOverridingInvoiceStatus":
                    expectedBody = JSON.stringify({
                        BD2_Location__c: 'someId',
                        Customer_PO__c: 'aReplacementOverridingInvoiceStatus',
                        Notes__c: "Overrode moneyManualAdjustments from -20 to 0\nOverrode moneyTax from 20 to 0\nOverrode moneyUnitCost from 333 to 0\nOverrode moneyTotal from 999 to 0",
                        Order_Type__c: 'Replacement',
                        BD2_Model__c: 'Standard',
                        Dealer_ID__c: null,
                        overrideReceiverName__c: null,
                        overrideEmail__c: null,
                        Currency__c: 'USD',
                        Invoice_Total__c: 0,
                        Manual_Adjustments__c: 0,
                        Shipping__c: 0,
                        Tax__c: 0,
                        Unit_Cost__c: 0,
                        Fulfillment_Reference__c: null,
                        Fulfillment_Date__c: null,
                        Order_Status__c: 'Ordered',
                        Quantity_Fulfilled__c: 0,
                        Quantity_Requested__c: 3,
                        Shipment_Date__c: null,
                        Shipping_Service__c: 'Standard',
                        Tracking_Carrier__c: null,
                        Tracking_Number__c: null,
                        Special_Inventory_Reference__c: null,
                        Invoice_Date__c: null,
                        Invoice_Number__c: null,
                        Invoice_Status__c: 'NA'
                    });
                    respObj = {
                        code: 201,
                        body: {
                            "id": "goodOverriddenStatus",
                            "success": true,
                            "errors": []
                        }
                    };
                    break;
                case "aShippedOrder":
                    expectedBody = JSON.stringify({
                        BD2_Location__c: 'someId',
                        Customer_PO__c: 'aShippedOrder',
                        Notes__c: null,
                        Order_Type__c: 'Free Sample',
                        BD2_Model__c: 'Standard',
                        Dealer_ID__c: null,
                        overrideReceiverName__c: null,
                        overrideEmail__c: null,
                        Currency__c: 'USD',
                        Invoice_Total__c: null,
                        Manual_Adjustments__c: null,
                        Shipping__c: null,
                        Tax__c: null,
                        Unit_Cost__c: null,
                        Fulfillment_Reference__c: null,
                        Fulfillment_Date__c: null,
                        Order_Status__c: 'Shipped',
                        Quantity_Fulfilled__c: 0,
                        Quantity_Requested__c: 1,
                        Shipment_Date__c: null,
                        Shipping_Service__c: 'Standard',
                        Tracking_Carrier__c: "Some Carrier",
                        Tracking_Number__c: "123456789",
                        Special_Inventory_Reference__c: null,
                        Invoice_Date__c: null,
                        Invoice_Number__c: null,
                        Invoice_Status__c: 'NA'
                    });
                    respObj = {
                        code: 201,
                        body: {
                            "id": "aPreShippedOrder",
                            "success": true,
                            "errors": []
                        }
                    };
                    break;
                case "aPausedOrder":
                    expectedBody = JSON.stringify({
                        BD2_Location__c: 'someId',
                        Customer_PO__c: 'aPausedOrder',
                        Notes__c: null,
                        Order_Type__c: 'Free Sample',
                        BD2_Model__c: 'Standard',
                        Dealer_ID__c: null,
                        overrideReceiverName__c: null,
                        overrideEmail__c: null,
                        Currency__c: 'USD',
                        Invoice_Total__c: null,
                        Manual_Adjustments__c: null,
                        Shipping__c: null,
                        Tax__c: null,
                        Unit_Cost__c: null,
                        Fulfillment_Reference__c: null,
                        Fulfillment_Date__c: null,
                        Order_Status__c: 'Paused',
                        Quantity_Fulfilled__c: 0,
                        Quantity_Requested__c: 1,
                        Shipment_Date__c: null,
                        Shipping_Service__c: 'Priority',
                        Tracking_Carrier__c: null,
                        Tracking_Number__c: null,
                        Special_Inventory_Reference__c: null,
                        Invoice_Date__c: null,
                        Invoice_Number__c: null,
                        Invoice_Status__c: 'NA'
                    });
                    respObj = {
                        code: 201,
                        body: {
                            "id": "aPrePausedOrder",
                            "success": true,
                            "errors": []
                        }
                    };
                    break;
                default:
                    throw `No match for ${body.Customer_PO__c}`;
            }
        }
        // PATCH
    }
    else {
        if (url.match(/conflictingValue$/i)) {
            expectedBody = JSON.stringify({
                Name: 'Yert',
                Business_Name__c: null,
                BD2_Account__c: 'someRandomIdLookATthis0mg',
                Receiver_Email_Address__c: null,
                Phone_Number__c: null,
                Dealer_ID__c: null,
                Receiver_Name__c: null,
                Street_Address__c: null,
                City__c: null,
                Province__c: 'NY - New York',
                Postal_Code__c: null,
                Country__c: null
            });
            respObj = createSuccess;
        }
        else if (url.match(/locationBeingTestedForUpdating$/i)) {
            expectedBody = JSON.stringify({
                Business_Name__c: "Some Business Without DealerID",
                Receiver_Email_Address__c: "thing@sympatico.nf.ca",
                Phone_Number__c: null,
                Dealer_ID__c: "theDealerId",
                Receiver_Name__c: "Person Q",
                Street_Address__c: "123 Street Street",
                City__c: "Glovertown",
                Province__c: 'KS - Kansas',
                Postal_Code__c: "88432-1234",
                Country__c: "US"
            });
            if (body.Business_Name__c === "This Should Fail") {
                throw "This should never have been requested";
            }
            respObj = updateOk;
        }
        else if (url.match(/fail/i)) {
            throw "This should never have happened";
        }
        else {
            throw `wtf u at ${url}`;
        }
    }
    // Return or fail
    if (opts.body != expectedBody) {
        let expected = JSON.parse(expectedBody);
        // Print out the differences
        for (const [k, v] of Object.entries(expected)) {
            if (Object.prototype.toString.call(v) === '[object Object]') {
                //@ts-ignore
                for (const [sk, sv] of Object.entries(v)) {
                    if (body[k][sk] !== sv) {
                        console.log(`${k} --> ${sk} --> Expected \"${sv}\" Got \"${body[k][sk]}\"`);
                    }
                }
            }
            else {
                if (body[k] !== v) {
                    console.log(`${k} --> Expected \"${v}\" Got \"${body[k]}\"`);
                }
            }
        }
        throw `Payload or url (${url}) was wrong`;
    }
    // Es Bueno
    return { body: respObj.body, status: respObj.code };
}
const createSuccess = {
    code: 201,
    body: {
        "id": "qQqQqQqQq",
        "success": true,
        "errors": []
    }
};
const updateOk = {
    code: 204,
    body: null
};
