import * as sfObjects from '../../salesforceTypes.js';
export declare const noLocationsFound: {
    req: {
        url: RegExp;
        code: number;
        body: {
            totalSize: number;
            done: boolean;
            records: never[];
        };
    };
    resp: never[];
};
export declare const locationThatExists: {
    req: {
        url: RegExp;
        code: number;
        body: {
            totalSize: number;
            done: boolean;
            records: {
                attributes: {
                    type: string;
                    url: string;
                };
                Id: string;
                BD2_Account__c: string;
                Name: string;
                Business_Name__c: string;
                Dealer_ID__c: string;
                Receiver_Name__c: string;
                Street_Address__c: string;
                City__c: string;
                Province__c: string;
                Postal_Code__c: string;
                Country__c: string;
                Phone_Number__c: string;
                Receiver_Email_Address__c: string;
                Shipping_Address__c: string;
                CreatedDate: string;
            }[];
        };
    };
    resp: {
        id: string;
        locationName: string;
        businessName: string;
        accountId: string;
        email: string;
        phone: string;
        dealerId: string;
        address: {
            receiverName: string;
            streetAddress: string;
            city: string;
            province: string;
            postalCode: string;
            country: string;
            fullAddress: string;
        };
    };
    orderResp: {
        id: string;
        accountId: string;
        locationId: string;
        internalOrderNumber: string;
        externalOrderNumber: string;
        notes: string;
        orderDetails: {
            orderType: string;
            bd2Model: string;
            dealerId: null;
            overrideEmail: null;
            overrideName: null;
        };
        money: {
            moneyCurrency: string;
            moneyTotal: null;
            moneyManualAdjustments: null;
            moneyShipping: null;
            moneyTax: null;
            moneyUnitCost: null;
            moneySubtotal: null;
        };
        fulfillment: {
            shopifyOrderID: null;
            fulfillmentDate: null;
            orderStatus: string;
            qtyFulfilled: number;
            qtyRequested: number;
            shippingDate: null;
            shippingService: null;
            shippingTrackingCarrier: string;
            shippingTrackingNumber: null;
            inventoryId: null;
        };
        invoicing: {
            invoiceDate: null;
            invoiceNumber: null;
            invoiceStatus: string;
        };
    }[];
    noOrderResp: never[];
};
export declare const locationsBelongsTosomeIdWithKids: {
    req: {
        url: RegExp;
        code: number;
        body: {
            totalSize: number;
            done: boolean;
            records: {
                attributes: {
                    type: string;
                    url: string;
                };
                Id: string;
                BD2_Account__c: string;
                Name: string;
                Business_Name__c: string;
                Dealer_ID__c: string;
                Receiver_Name__c: string;
                Street_Address__c: string;
                City__c: string;
                Province__c: string;
                Postal_Code__c: string;
                Country__c: string;
                Phone_Number__c: string;
                Receiver_Email_Address__c: string;
                Shipping_Address__c: string;
                CreatedDate: string;
            }[];
        };
    };
    resp: {
        id: string;
        locationName: string;
        businessName: string;
        accountId: string;
        email: string;
        phone: string;
        dealerId: string;
        address: {
            receiverName: string;
            streetAddress: string;
            city: string;
            province: string;
            postalCode: string;
            country: string;
            fullAddress: string;
        };
    }[];
};
export declare const locationWithReturnsOne: {
    req: {
        url: RegExp;
        code: number;
        body: {
            totalSize: number;
            done: boolean;
            records: {
                attributes: {
                    type: string;
                    url: string;
                };
                Id: string;
                BD2_Account__c: string;
                Name: string;
                Business_Name__c: string;
                Dealer_ID__c: string;
                Receiver_Name__c: string;
                Street_Address__c: string;
                City__c: string;
                Province__c: string;
                Postal_Code__c: string;
                Country__c: string;
                Phone_Number__c: string;
                Receiver_Email_Address__c: string;
                Shipping_Address__c: string;
                CreatedDate: string;
            }[];
        };
    };
};
export declare function checkLocationBody(url: string, opts: sfObjects.genericObj): {
    body: {
        message: string;
        errorCode: string;
        fields: string[];
    }[] | {
        id: string;
        success: boolean;
        errors: never[];
    } | null;
    status: number;
};
