export const noOrdersFound = {
    req: {
        url: /FROM%20BD2_Order__c%20WHERE%20Order_Status__c%20=%20%27Paused%27$|WHERE%20Special_Inventory_Reference__c%20=%20%27aResultById%27%20AND%20Order_Status__c%20=%20%27Ordered%27$/,
        code: 200,
        body: {
            "totalSize": 0,
            "done": true,
            "records": []
        }
    },
    resp: []
};
export const getNewOrdersSuccessful = {
    req: {
        url: /FROM%20BD2_Order__c%20WHERE%20Order_Status__c%20=%20%27Ordered%27$/,
        code: 200,
        body: {
            "totalSize": 1,
            "done": true,
            "records": [
                {
                    "attributes": {
                        "type": "BD2_Order__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Order__c/a0jJA0000002N3BYAU"
                    },
                    "Id": "newOrder1",
                    'accountID__c': 'parentOne',
                    "BD2_Location__c": "someOtherLocation",
                    "Name": "BD2-000053",
                    "Customer_PO__c": "FreeSAmple123",
                    "Order_Type__c": "Free Sample",
                    "BD2_Model__c": "Standard",
                    "Dealer_ID__c": null,
                    "Currency__c": "CAD",
                    "Invoice_Total__c": null,
                    "Manual_Adjustments__c": null,
                    "Shipping__c": null,
                    "Tax__c": null,
                    "Unit_Cost__c": null,
                    "Fulfillment_Reference__c": null,
                    "Fulfillment_Date__c": null,
                    "Order_Status__c": "Ordered",
                    "Quantity_Fulfilled__c": 0,
                    "Quantity_Requested__c": 2,
                    "Shipment_Date__c": null,
                    "Shipping_Service__c": "Priority",
                    "Tracking_Carrier__c": "Local FedEx",
                    "Tracking_Number__c": null,
                    "Special_Inventory_Reference__c": null,
                    "Invoice_Date__c": null,
                    "Invoice_Number__c": null,
                    "Invoice_Status__c": "NA",
                    'Notes__c': ""
                }
            ]
        }
    },
    resp: [{
            id: "newOrder1",
            accountId: 'parentOne',
            locationId: "someOtherLocation",
            internalOrderNumber: "BD2-000053",
            externalOrderNumber: "FreeSAmple123",
            notes: "",
            orderDetails: {
                orderType: "Free Sample",
                bd2Model: "Standard",
                dealerId: null,
                overrideEmail: null,
                overrideName: null
            },
            money: {
                moneyCurrency: "CAD",
                moneyTotal: null,
                moneyManualAdjustments: null,
                moneyShipping: null,
                moneyTax: null,
                moneyUnitCost: null,
                moneySubtotal: null
            },
            fulfillment: {
                shopifyOrderID: null,
                fulfillmentDate: null,
                orderStatus: "Ordered",
                qtyFulfilled: 0,
                qtyRequested: 2,
                shippingDate: null,
                shippingService: "Priority",
                shippingTrackingCarrier: "Local FedEx",
                shippingTrackingNumber: null,
                inventoryId: null,
            },
            invoicing: {
                invoiceDate: null,
                invoiceNumber: null,
                invoiceStatus: "NA"
            }
        }]
};
export const getUnshippedOrdersSuccessful = {
    req: {
        url: /WHERE%20\(Order_Status__c%20=%20%27Fulfilling%27%20OR%20Order_Status__c%20=%20%27Paused%27%20OR%20Order_Status__c%20=%20%27Partially%20Shipped%27\)$/,
        code: 200,
        body: {
            "totalSize": 2,
            "done": true,
            "records": [
                {
                    "attributes": {
                        "type": "BD2_Order__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Order__c/a0jJA0000002N3BYAU"
                    },
                    "Id": "unshippedOrder1",
                    'accountID__c': 'parentOne',
                    "BD2_Location__c": "unshippedParent",
                    "Name": "BD2-000006",
                    "Customer_PO__c": "externalOrder1",
                    "Order_Type__c": "Replacement - From Bulk",
                    "BD2_Model__c": "Standard",
                    "Dealer_ID__c": null,
                    "Currency__c": "USD",
                    "Invoice_Total__c": null,
                    "Manual_Adjustments__c": null,
                    "Shipping__c": null,
                    "Tax__c": null,
                    "Unit_Cost__c": null,
                    "Fulfillment_Reference__c": null,
                    "Fulfillment_Date__c": null,
                    "Order_Status__c": "Ordered",
                    "Quantity_Fulfilled__c": 0,
                    "Quantity_Requested__c": 14,
                    "Shipment_Date__c": null,
                    "Shipping_Service__c": "Standard",
                    "Tracking_Carrier__c": null,
                    "Tracking_Number__c": null,
                    "Special_Inventory_Reference__c": "someBulkReplacmentId",
                    "Invoice_Date__c": null,
                    "Invoice_Number__c": null,
                    "Invoice_Status__c": "NA",
                    'Notes__c': ""
                },
                {
                    "attributes": {
                        "type": "BD2_Order__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Order__c/a0jJA0000002N3gYAE"
                    },
                    "Id": "unshippedOrder2",
                    'accountID__c': 'parentTwo',
                    "BD2_Location__c": "unshippedParent",
                    "Name": "BD2-000007",
                    "Customer_PO__c": null,
                    "Order_Type__c": "Order - Invoiced",
                    "BD2_Model__c": "Standard",
                    "Dealer_ID__c": "12345",
                    "Currency__c": "USD",
                    "Invoice_Total__c": 1234.52,
                    "Manual_Adjustments__c": null,
                    "Shipping__c": 12,
                    "Tax__c": 5,
                    "Unit_Cost__c": 100,
                    "Subtotal__c": 23,
                    "Fulfillment_Reference__c": null,
                    "Fulfillment_Date__c": null,
                    "Order_Status__c": "Fulfilling",
                    "Quantity_Fulfilled__c": 1,
                    "Quantity_Requested__c": 1,
                    "Shipment_Date__c": null,
                    "Shipping_Service__c": null,
                    "Tracking_Carrier__c": null,
                    "Tracking_Number__c": null,
                    "Special_Inventory_Reference__c": null,
                    "Invoice_Date__c": "2023-06-09T14:31:28.742Z",
                    "Invoice_Number__c": "123456",
                    "Invoice_Status__c": "Sent",
                    'Notes__c': ""
                }
            ]
        }
    },
    resp: [{
            id: "unshippedOrder1",
            accountId: 'parentOne',
            locationId: "unshippedParent",
            internalOrderNumber: "BD2-000006",
            externalOrderNumber: "externalOrder1",
            notes: "",
            orderDetails: {
                orderType: "Replacement - From Bulk",
                bd2Model: "Standard",
                dealerId: null,
                overrideEmail: null,
                overrideName: null
            },
            money: {
                moneyCurrency: "USD",
                moneyTotal: null,
                moneyManualAdjustments: null,
                moneyShipping: null,
                moneyTax: null,
                moneyUnitCost: null,
                moneySubtotal: null
            },
            fulfillment: {
                shopifyOrderID: null,
                fulfillmentDate: null,
                orderStatus: "Ordered",
                qtyFulfilled: 0,
                qtyRequested: 14,
                shippingDate: null,
                shippingService: "Standard",
                shippingTrackingCarrier: null,
                shippingTrackingNumber: null,
                inventoryId: 'someBulkReplacmentId',
            },
            invoicing: {
                invoiceDate: null,
                invoiceNumber: null,
                invoiceStatus: "NA"
            }
        },
        {
            id: "unshippedOrder2",
            accountId: 'parentTwo',
            locationId: "unshippedParent",
            internalOrderNumber: "BD2-000007",
            externalOrderNumber: null,
            notes: "",
            orderDetails: {
                orderType: "Order - Invoiced",
                bd2Model: "Standard",
                dealerId: "12345",
                overrideEmail: null,
                overrideName: null
            },
            money: {
                moneyCurrency: "USD",
                moneyTotal: 1234.52,
                moneyManualAdjustments: null,
                moneyShipping: 12,
                moneyTax: 5,
                moneyUnitCost: 100,
                moneySubtotal: 23
            },
            fulfillment: {
                shopifyOrderID: null,
                fulfillmentDate: null,
                orderStatus: "Fulfilling",
                qtyFulfilled: 1,
                qtyRequested: 1,
                shippingDate: null,
                shippingService: null,
                shippingTrackingCarrier: null,
                shippingTrackingNumber: null,
                inventoryId: null,
            },
            invoicing: {
                invoiceDate: new Date("2023-06-09T14:31:28.742Z"),
                invoiceNumber: "123456",
                invoiceStatus: "Sent"
            }
        }]
};
export const getInternalIdDoesntExist = {
    req: {
        url: /FROM%20BD2_Order__c%20WHERE%20Name%20=%20%27omgBBQ%27$/,
        code: 200,
        body: {
            "totalSize": 0,
            "done": true,
            "records": []
        }
    },
    resp: []
};
export const getOrderInternalId = {
    req: {
        url: /FROM%20BD2_Order__c%20WHERE%20Name%20=%20%27BD2-123456%27$|WHERE%20\(BD2_Location__c%20=%20%27ARealIdThatExists%27%20OR%20BD2_Location__c%20=%20%27ARealIdThatExi%27\)%20AND%20Order_Status__c%20=%20%27Ordered%27$|WHERE%20Id%20=%20%27SomeId123%27$/,
        code: 200,
        body: {
            "totalSize": 1,
            "done": true,
            "records": [
                {
                    "attributes": {
                        "type": "BD2_Order__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Order__c/a0jJA0000002N3BYAU"
                    },
                    "Id": "SomeId123",
                    'accountID__c': 'parentThree',
                    "BD2_Location__c": "ARealIdThatExists",
                    "Name": "BD2-123456",
                    "Customer_PO__c": "FreeSAmple123",
                    "Order_Type__c": "Free Sample",
                    "BD2_Model__c": "Standard",
                    "Dealer_ID__c": null,
                    "Currency__c": "CAD",
                    "Invoice_Total__c": null,
                    "Manual_Adjustments__c": null,
                    "Shipping__c": null,
                    "Tax__c": null,
                    "Unit_Cost__c": null,
                    "Fulfillment_Reference__c": null,
                    "Fulfillment_Date__c": null,
                    "Order_Status__c": "Ordered",
                    "Quantity_Fulfilled__c": 1,
                    "Quantity_Requested__c": 1,
                    "Shipment_Date__c": null,
                    "Shipping_Service__c": null,
                    "Tracking_Carrier__c": "USPS",
                    "Tracking_Number__c": null,
                    "Special_Inventory_Reference__c": null,
                    "Invoice_Date__c": null,
                    "Invoice_Number__c": null,
                    "Invoice_Status__c": "NA",
                    'Notes__c': ""
                }
            ]
        }
    },
    resp: [{
            id: "SomeId123",
            accountId: 'parentThree',
            locationId: "ARealIdThatExists",
            internalOrderNumber: "BD2-123456",
            externalOrderNumber: "FreeSAmple123",
            notes: "",
            orderDetails: {
                orderType: "Free Sample",
                bd2Model: "Standard",
                dealerId: null,
                overrideEmail: null,
                overrideName: null
            },
            money: {
                moneyCurrency: "CAD",
                moneyTotal: null,
                moneyManualAdjustments: null,
                moneyShipping: null,
                moneyTax: null,
                moneyUnitCost: null,
                moneySubtotal: null
            },
            fulfillment: {
                shopifyOrderID: null,
                fulfillmentDate: null,
                orderStatus: "Ordered",
                qtyFulfilled: 1,
                qtyRequested: 1,
                shippingDate: null,
                shippingService: null,
                shippingTrackingCarrier: "USPS",
                shippingTrackingNumber: null,
                inventoryId: null,
            },
            invoicing: {
                invoiceDate: null,
                invoiceNumber: null,
                invoiceStatus: "NA"
            }
        }]
};
export const getOrderExternalId = {
    req: {
        url: /FROM%20BD2_Order__c%20WHERE%20Customer_PO__c%20=%20%27SomeCustomerPO%27$/,
        code: 200,
        body: {
            "totalSize": 1,
            "done": true,
            "records": [
                {
                    "attributes": {
                        "type": "BD2_Order__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Order__c/a0jJA0000002N3BYAU"
                    },
                    "Id": "SomeId321",
                    'accountID__c': 'parentFour',
                    "BD2_Location__c": "someOtherLocation",
                    "Name": "BD2-666",
                    "Customer_PO__c": "SomeCustomerPO",
                    "Order_Type__c": "Free Sample",
                    "BD2_Model__c": "Standard",
                    "Dealer_ID__c": null,
                    "Currency__c": "CAD",
                    "Invoice_Total__c": null,
                    "Manual_Adjustments__c": null,
                    "Shipping__c": null,
                    "Tax__c": null,
                    "Unit_Cost__c": null,
                    "Fulfillment_Reference__c": null,
                    "Fulfillment_Date__c": null,
                    "Order_Status__c": "Ordered",
                    "Quantity_Fulfilled__c": 1,
                    "Quantity_Requested__c": 1,
                    "Shipment_Date__c": null,
                    "Shipping_Service__c": "Standard",
                    "Tracking_Carrier__c": null,
                    "Tracking_Number__c": null,
                    "Special_Inventory_Reference__c": null,
                    "Invoice_Date__c": "2023-06-19T16:32:53.365Z",
                    "Invoice_Number__c": null,
                    "Invoice_Status__c": "NA",
                    'Notes__c': ""
                }
            ]
        }
    },
    resp: [{
            id: "SomeId321",
            accountId: 'parentFour',
            locationId: "someOtherLocation",
            internalOrderNumber: "BD2-666",
            externalOrderNumber: "SomeCustomerPO",
            notes: "",
            orderDetails: {
                orderType: "Free Sample",
                bd2Model: "Standard",
                dealerId: null,
                overrideEmail: null,
                overrideName: null
            },
            money: {
                moneyCurrency: "CAD",
                moneyTotal: null,
                moneyManualAdjustments: null,
                moneyShipping: null,
                moneyTax: null,
                moneyUnitCost: null,
                moneySubtotal: null
            },
            fulfillment: {
                shopifyOrderID: null,
                fulfillmentDate: null,
                orderStatus: "Ordered",
                qtyFulfilled: 1,
                qtyRequested: 1,
                shippingDate: null,
                shippingService: "Standard",
                shippingTrackingCarrier: null,
                shippingTrackingNumber: null,
                inventoryId: null,
            },
            invoicing: {
                invoiceDate: new Date("2023-06-19T16:32:53.365Z"),
                invoiceNumber: null,
                invoiceStatus: "NA"
            }
        }],
    sfObject: {
        "BD2_Location__c": "someOtherLocation",
        "Customer_PO__c": "SomeCustomerPO",
        "Order_Type__c": "Free Sample",
        "BD2_Model__c": "Standard",
        "Dealer_ID__c": null,
        "Currency__c": "CAD",
        "Invoice_Total__c": null,
        "Manual_Adjustments__c": null,
        "Shipping__c": null,
        "Tax__c": null,
        "Unit_Cost__c": null,
        "overrideEmail__c": null,
        "overrideReceiverName__c": null,
        "Fulfillment_Reference__c": null,
        "Fulfillment_Date__c": null,
        "Order_Status__c": "Ordered",
        "Quantity_Fulfilled__c": 1,
        "Quantity_Requested__c": 1,
        "Shipment_Date__c": null,
        "Shipping_Service__c": "Standard",
        "Tracking_Carrier__c": null,
        "Tracking_Number__c": null,
        "Special_Inventory_Reference__c": null,
        "Invoice_Date__c": "2023-06-19T16:32:53.365Z",
        "Invoice_Number__c": null,
        "Invoice_Status__c": "NA",
        'Notes__c': ""
    }
};
export const noOrdersForParentAccount = {
    req: {
        url: /WHERE%20\(accountID__c%20=%20%27someRandomIdLookATthis0mg%27%20OR%20accountID__c%20=%20%27someRandomIdLookATthis%27\)%20AND%20Order_Status__c%20=%20%27Ordered%27$|WHERE%20\(BD2_Location__c%20=%20%27ARealIdThatExists%27%20OR%20BD2_Location__c%20=%20%27ARealIdThatExi%27\)%20AND%20Order_Status__c%20=%20%27Paused%27$/,
        code: 200,
        body: {
            "totalSize": 0,
            "done": true,
            "records": []
        }
    },
    resp: []
};
export const orderWhatBelongsToAccount = {
    req: {
        url: /WHERE%20accountID__c%20=%20%27someIdWithKids%27%20AND%20Order_Status__c%20=%20%27Paused%27$/,
        code: 200,
        body: {
            "totalSize": 1,
            "done": true,
            "records": [
                {
                    "attributes": {
                        "type": "BD2_Order__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Order__c/a0jJA0000002N3BYAU"
                    },
                    "Id": "anotheId",
                    'accountID__c': 'someIdWithKids',
                    "BD2_Location__c": "somePlace",
                    "Name": "BD2-999",
                    "Customer_PO__c": "SomeCustomerPO",
                    "Order_Type__c": "Free Sample",
                    "BD2_Model__c": "Standard",
                    "Dealer_ID__c": null,
                    "Currency__c": "CAD",
                    "Invoice_Total__c": null,
                    "Manual_Adjustments__c": null,
                    "Shipping__c": null,
                    "Tax__c": null,
                    "Unit_Cost__c": null,
                    "Fulfillment_Reference__c": null,
                    "Fulfillment_Date__c": null,
                    "Order_Status__c": "Paused",
                    "Quantity_Fulfilled__c": 1,
                    "Quantity_Requested__c": 1,
                    "Shipment_Date__c": null,
                    "Shipping_Service__c": null,
                    "Tracking_Carrier__c": null,
                    "Tracking_Number__c": null,
                    "Special_Inventory_Reference__c": null,
                    "Invoice_Date__c": null,
                    "Invoice_Number__c": null,
                    "Invoice_Status__c": "NA",
                    'Notes__c': ""
                }
            ]
        }
    },
    resp: [{
            id: "anotheId",
            accountId: 'someIdWithKids',
            locationId: "somePlace",
            internalOrderNumber: "BD2-999",
            externalOrderNumber: "SomeCustomerPO",
            notes: "",
            orderDetails: {
                orderType: "Free Sample",
                bd2Model: "Standard",
                dealerId: null,
                overrideEmail: null,
                overrideName: null
            },
            money: {
                moneyCurrency: "CAD",
                moneyTotal: null,
                moneyManualAdjustments: null,
                moneyShipping: null,
                moneyTax: null,
                moneyUnitCost: null,
                moneySubtotal: null
            },
            fulfillment: {
                shopifyOrderID: null,
                fulfillmentDate: null,
                orderStatus: "Paused",
                qtyFulfilled: 1,
                qtyRequested: 1,
                shippingDate: null,
                shippingService: null,
                shippingTrackingCarrier: null,
                shippingTrackingNumber: null,
                inventoryId: null,
            },
            invoicing: {
                invoiceDate: null,
                invoiceNumber: null,
                invoiceStatus: "NA"
            }
        }]
};
export const paginationTestCase = {
    responseOne: {
        url: /WHERE%20accountID__c%20=%20%27paginationTest%27%20AND%20Order_Status__c%20=%20%27Ordered%27$|WHERE%20\(Special_Inventory_Reference__c%20=%20%27resultByFilterOneId%27%20OR%20Special_Inventory_Reference__c%20=%20%27resultByFilterOn%27\)%20AND%20Order_Status__c%20=%20%27Ordered%27$/,
        code: 200,
        body: {
            "totalSize": 3,
            "done": false,
            "nextRecordsUrl": "/paginationTestPage2",
            "records": [
                {
                    "attributes": {
                        "type": "BD2_Order__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Order__c/a0jJA0000002N3BYAU"
                    },
                    "Id": "1",
                    'accountID__c': 'paginationTest',
                    "BD2_Location__c": "someOtherLocation",
                    "Name": "BD2-Page-1",
                    "Customer_PO__c": "BD2-Page-1",
                    "Order_Type__c": "Free Sample",
                    "BD2_Model__c": "Standard",
                    "Dealer_ID__c": null,
                    "Currency__c": "CAD",
                    "Invoice_Total__c": null,
                    "Manual_Adjustments__c": null,
                    "Shipping__c": null,
                    "Tax__c": null,
                    "Unit_Cost__c": null,
                    "Fulfillment_Reference__c": null,
                    "Fulfillment_Date__c": null,
                    "Order_Status__c": "Ordered",
                    "Quantity_Fulfilled__c": 0,
                    "Quantity_Requested__c": 1,
                    "Shipment_Date__c": null,
                    "Shipping_Service__c": null,
                    "Tracking_Carrier__c": null,
                    "Tracking_Number__c": null,
                    "Special_Inventory_Reference__c": null,
                    "Invoice_Date__c": null,
                    "Invoice_Number__c": null,
                    "Invoice_Status__c": "NA",
                    'Notes__c': ""
                }
            ]
        }
    },
    responseTwo: {
        url: /\/paginationTestPage2$/,
        code: 200,
        body: {
            "totalSize": 3,
            "done": false,
            "nextRecordsUrl": "/paginationTestPage3",
            "records": [
                {
                    "attributes": {
                        "type": "BD2_Order__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Order__c/a0jJA0000002N3BYAU"
                    },
                    "Id": "2",
                    'accountID__c': 'paginationTest',
                    "BD2_Location__c": "someOtherLocation",
                    "Name": "BD2-Page-2",
                    "Customer_PO__c": "BD2-Page-2",
                    "Order_Type__c": "Free Sample",
                    "BD2_Model__c": "Standard",
                    "Dealer_ID__c": null,
                    "Currency__c": "CAD",
                    "Invoice_Total__c": null,
                    "Manual_Adjustments__c": null,
                    "Shipping__c": null,
                    "Tax__c": null,
                    "Unit_Cost__c": null,
                    "Fulfillment_Reference__c": null,
                    "Fulfillment_Date__c": null,
                    "Order_Status__c": "Ordered",
                    "Quantity_Fulfilled__c": 0,
                    "Quantity_Requested__c": 1,
                    "Shipment_Date__c": null,
                    "Shipping_Service__c": null,
                    "Tracking_Carrier__c": null,
                    "Tracking_Number__c": null,
                    "Special_Inventory_Reference__c": null,
                    "Invoice_Date__c": null,
                    "Invoice_Number__c": null,
                    "Invoice_Status__c": "NA",
                    'Notes__c': ""
                }
            ]
        }
    },
    responseThree: {
        url: /\/paginationTestPage3$/,
        code: 200,
        body: {
            "totalSize": 3,
            "done": true,
            "records": [
                {
                    "attributes": {
                        "type": "BD2_Order__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Order__c/a0jJA0000002N3BYAU"
                    },
                    "Id": "3",
                    'accountID__c': 'paginationTest',
                    "BD2_Location__c": "someOtherLocation",
                    "Name": "BD2-Page-3",
                    "Customer_PO__c": "BD2-Page-3",
                    "Order_Type__c": "Free Sample",
                    "BD2_Model__c": "Standard",
                    "Dealer_ID__c": null,
                    "Currency__c": "CAD",
                    "Invoice_Total__c": null,
                    "Manual_Adjustments__c": null,
                    "Shipping__c": null,
                    "Tax__c": null,
                    "Unit_Cost__c": null,
                    "Fulfillment_Reference__c": null,
                    "Fulfillment_Date__c": null,
                    "Order_Status__c": "Ordered",
                    "Quantity_Fulfilled__c": 0,
                    "Quantity_Requested__c": 1,
                    "Shipment_Date__c": null,
                    "Shipping_Service__c": null,
                    "Tracking_Carrier__c": null,
                    "Tracking_Number__c": null,
                    "Special_Inventory_Reference__c": null,
                    "Invoice_Date__c": null,
                    "Invoice_Number__c": null,
                    "Invoice_Status__c": "NA",
                    'Notes__c': ""
                }
            ]
        }
    },
    expectedResults: [
        {
            id: "1",
            accountId: 'paginationTest',
            locationId: "someOtherLocation",
            internalOrderNumber: "BD2-Page-1",
            externalOrderNumber: "BD2-Page-1",
            notes: "",
            orderDetails: {
                orderType: "Free Sample",
                bd2Model: "Standard",
                dealerId: null,
                overrideEmail: null,
                overrideName: null
            },
            money: {
                moneyCurrency: "CAD",
                moneyTotal: null,
                moneyManualAdjustments: null,
                moneyShipping: null,
                moneyTax: null,
                moneyUnitCost: null,
                moneySubtotal: null
            },
            fulfillment: {
                shopifyOrderID: null,
                fulfillmentDate: null,
                orderStatus: "Ordered",
                qtyFulfilled: 0,
                qtyRequested: 1,
                shippingDate: null,
                shippingService: null,
                shippingTrackingCarrier: null,
                shippingTrackingNumber: null,
                inventoryId: null,
            },
            invoicing: {
                invoiceDate: null,
                invoiceNumber: null,
                invoiceStatus: "NA"
            }
        },
        {
            id: "2",
            accountId: 'paginationTest',
            locationId: "someOtherLocation",
            internalOrderNumber: "BD2-Page-2",
            externalOrderNumber: "BD2-Page-2",
            notes: "",
            orderDetails: {
                orderType: "Free Sample",
                bd2Model: "Standard",
                dealerId: null,
                overrideEmail: null,
                overrideName: null
            },
            money: {
                moneyCurrency: "CAD",
                moneyTotal: null,
                moneyManualAdjustments: null,
                moneyShipping: null,
                moneyTax: null,
                moneyUnitCost: null,
                moneySubtotal: null
            },
            fulfillment: {
                shopifyOrderID: null,
                fulfillmentDate: null,
                orderStatus: "Ordered",
                qtyFulfilled: 0,
                qtyRequested: 1,
                shippingDate: null,
                shippingService: null,
                shippingTrackingCarrier: null,
                shippingTrackingNumber: null,
                inventoryId: null,
            },
            invoicing: {
                invoiceDate: null,
                invoiceNumber: null,
                invoiceStatus: "NA"
            }
        },
        {
            id: "3",
            accountId: 'paginationTest',
            locationId: "someOtherLocation",
            internalOrderNumber: "BD2-Page-3",
            externalOrderNumber: "BD2-Page-3",
            notes: "",
            orderDetails: {
                orderType: "Free Sample",
                bd2Model: "Standard",
                dealerId: null,
                overrideEmail: null,
                overrideName: null
            },
            money: {
                moneyCurrency: "CAD",
                moneyTotal: null,
                moneyManualAdjustments: null,
                moneyShipping: null,
                moneyTax: null,
                moneyUnitCost: null,
                moneySubtotal: null
            },
            fulfillment: {
                shopifyOrderID: null,
                fulfillmentDate: null,
                orderStatus: "Ordered",
                qtyFulfilled: 0,
                qtyRequested: 1,
                shippingDate: null,
                shippingService: null,
                shippingTrackingCarrier: null,
                shippingTrackingNumber: null,
                inventoryId: null,
            },
            invoicing: {
                invoiceDate: null,
                invoiceNumber: null,
                invoiceStatus: "NA"
            }
        }
    ]
};
// Plays the role of the server checking that the header token is set properly
export function checkHeaderToken(opts, goodResp, expectedToken) {
    if (!opts.headers.hasOwnProperty('Authorization')) {
        throw 'No auth token provided in header';
    }
    if (opts.headers['Authorization'] !== `Bearer ${expectedToken}`) {
        throw `Expected token ${expectedToken} but got ${opts['Authorization']}`;
    }
    return goodResp;
}
export function checkOrderBody(url, opts) {
    if (opts.headers['Content-Type'] !== 'application/json') {
        throw `Any post/patch gotta be application/json`;
    }
    let body = JSON.parse(opts.body);
    let respObj = null;
    if (opts.method === 'POST' && url.match(/__c\/$/)) {
        switch (body.BD2_Location__c) {
            case "dontExistBy":
                respObj = createNonExistantLocationId;
                break;
            case "malformedLocatinId":
                respObj = createMalformedLocationId;
                break;
            case "allGoodBro":
                let expectedBody = JSON.stringify({
                    BD2_Location__c: 'allGoodBro',
                    Customer_PO__c: 'asdf1321',
                    Notes__c: null,
                    Order_Type__c: 'Replacement',
                    BD2_Model__c: 'Standard',
                    Currency__c: 'CAD',
                    Invoice_Total__c: null,
                    Manual_Adjustments__c: null,
                    Shipping__c: null,
                    Tax__c: null,
                    Unit_Cost__c: null,
                    Order_Status__c: 'Ordered',
                    Quantity_Requested__c: 5,
                    Shipping_Service__c: 'Priority',
                    Invoice_Status__c: 'NA'
                });
                if (expectedBody != opts.body) {
                    console.log(opts.body);
                    throw 'body mismatch';
                }
                respObj = createSuccess;
                break;
            default:
                throw `bad location ID for testing @ ${body.BD2_Location__c}`;
        }
    }
    else if (opts.method === 'PATCH') {
        if (url.match(/duplicateId$/i)) {
            respObj = createDuplicate;
        }
        else if (url.match(/malformedId$/)) {
            respObj = createMalformedLocationId;
        }
        else if (url.match(/dontExistBy$/)) {
            respObj = createNonExistantLocationId;
        }
        else if (url.match(/someOrderIdToUpdate$/)) {
            respObj = updateOk;
        }
        else if (url.match(/updateMissingFields$/)) {
            respObj = createMissingField;
        }
        else {
            throw `Bad patch URL ${url}`;
        }
    }
    else {
        throw `Bad test - ended up with method ${opts.method}`;
    }
    return { body: respObj.body, status: respObj.code };
}
const createDuplicate = {
    code: 400,
    body: [
        {
            "message": "duplicate value found: Name duplicates value on record with id: a0gJA0000000SvBYAU",
            "errorCode": "DUPLICATE_VALUE",
            "fields": []
        }
    ]
};
const updateOk = {
    code: 204,
    body: null
};
const createSuccess = {
    code: 201,
    body: {
        "id": "someNewOrderId",
        "success": true,
        "errors": []
    }
};
const createMissingField = {
    code: 400,
    body: [
        {
            "message": "Required fields are missing: [BD2_Account__c ET AL]",
            "errorCode": "REQUIRED_FIELD_MISSING",
            "fields": [
                "BLAH BLAH",
                "I'M MISSING"
            ]
        }
    ]
};
const createNonExistantLocationId = {
    code: 400,
    body: [
        {
            "message": "invalid cross reference id",
            "errorCode": "INVALID_CROSS_REFERENCE_KEY",
            "fields": []
        }
    ]
};
const createMalformedLocationId = {
    code: 400,
    body: [
        {
            "message": "Parent Account: id value of incorrect type: ASDAD",
            "errorCode": "MALFORMED_ID",
            "fields": [
                "BD2_Location__c",
            ]
        }
    ]
};
