export declare const queryGeneratorTestCases: {
    order: ({
        requiredData: string[];
        filters: {
            internalOrderNumber: string;
            orderStatus: string;
            externalOrderNumber?: undefined;
            invoiceNumber?: undefined;
            locationId?: undefined;
        };
        expected: string;
    } | {
        requiredData: string[];
        filters: {
            internalOrderNumber: string;
            orderStatus: null;
            externalOrderNumber?: undefined;
            invoiceNumber?: undefined;
            locationId?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            internalOrderNumber: string;
            orderStatus?: undefined;
            externalOrderNumber?: undefined;
            invoiceNumber?: undefined;
            locationId?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            externalOrderNumber: string;
            orderStatus: string;
            internalOrderNumber?: undefined;
            invoiceNumber?: undefined;
            locationId?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            invoiceNumber: (string | null)[];
            orderStatus: string;
            internalOrderNumber?: undefined;
            externalOrderNumber?: undefined;
            locationId?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            invoiceNumber: string;
            internalOrderNumber?: undefined;
            orderStatus?: undefined;
            externalOrderNumber?: undefined;
            locationId?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            invoiceNumber: string;
            orderStatus: null;
            internalOrderNumber?: undefined;
            externalOrderNumber?: undefined;
            locationId?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            locationId: string;
            orderStatus: string;
            internalOrderNumber?: undefined;
            externalOrderNumber?: undefined;
            invoiceNumber?: undefined;
        };
        expected: string;
    })[];
    account: ({
        requiredData: never[];
        filters: {
            accountName: string;
            type: string;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            accountName: string;
            type?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            type: string;
            accountName?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            accountName?: undefined;
            type?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: null;
        expected: string;
    })[];
    location: ({
        requiredData: string[];
        filters: {
            accountId: string;
            receiverName: string;
            locationName?: undefined;
            streetAddress?: undefined;
            businessName?: undefined;
            dealerId?: undefined;
            email?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            receiverName: string;
            locationName: null;
            accountId?: undefined;
            streetAddress?: undefined;
            businessName?: undefined;
            dealerId?: undefined;
            email?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            locationName: string;
            streetAddress: string;
            accountId?: undefined;
            receiverName?: undefined;
            businessName?: undefined;
            dealerId?: undefined;
            email?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            businessName: string;
            dealerId: string;
            accountId?: undefined;
            receiverName?: undefined;
            locationName?: undefined;
            streetAddress?: undefined;
            email?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            email: string;
            dealerId: string;
            accountId?: undefined;
            receiverName?: undefined;
            locationName?: undefined;
            streetAddress?: undefined;
            businessName?: undefined;
        };
        expected: string;
    })[];
    inventory: ({
        requiredData: never[];
        filters: {
            accountId: string;
            allowReplacement: boolean;
            isInventoryAvailable?: undefined;
            inventoryName?: undefined;
            allowNew?: undefined;
            inventoryType?: undefined;
            qtyAvailable?: undefined;
            shopifyVariantId?: undefined;
            created?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            isInventoryAvailable: boolean;
            accountId?: undefined;
            allowReplacement?: undefined;
            inventoryName?: undefined;
            allowNew?: undefined;
            inventoryType?: undefined;
            qtyAvailable?: undefined;
            shopifyVariantId?: undefined;
            created?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            inventoryName: string;
            allowNew: boolean;
            accountId?: undefined;
            allowReplacement?: undefined;
            isInventoryAvailable?: undefined;
            inventoryType?: undefined;
            qtyAvailable?: undefined;
            shopifyVariantId?: undefined;
            created?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            inventoryType: string;
            qtyAvailable: number;
            accountId?: undefined;
            allowReplacement?: undefined;
            isInventoryAvailable?: undefined;
            inventoryName?: undefined;
            allowNew?: undefined;
            shopifyVariantId?: undefined;
            created?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            shopifyVariantId: string;
            accountId?: undefined;
            allowReplacement?: undefined;
            isInventoryAvailable?: undefined;
            inventoryName?: undefined;
            allowNew?: undefined;
            inventoryType?: undefined;
            qtyAvailable?: undefined;
            created?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            qtyAvailable: string;
            created: string;
            accountId?: undefined;
            allowReplacement?: undefined;
            isInventoryAvailable?: undefined;
            inventoryName?: undefined;
            allowNew?: undefined;
            inventoryType?: undefined;
            shopifyVariantId?: undefined;
        };
        expected: string;
    })[];
    return: ({
        requiredData: never[];
        filters: {
            fate: string[];
            inventoryId: string;
            referenceNumber?: undefined;
            locationId?: undefined;
            testResults?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            referenceNumber: string;
            locationId: string[];
            fate?: undefined;
            inventoryId?: undefined;
            testResults?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            testResults: string;
            fate?: undefined;
            inventoryId?: undefined;
            referenceNumber?: undefined;
            locationId?: undefined;
        };
        expected: string;
    } | {
        requiredData: never[];
        filters: {
            inventoryId: string;
            fate?: undefined;
            referenceNumber?: undefined;
            locationId?: undefined;
            testResults?: undefined;
        };
        expected: string;
    })[];
};
