import util from 'util';
import * as testAccountCases from './salesforce.cases.accounts.js';
import * as testLocations from './salesforce.cases.locations.js';
// name: "Bob Of Mainframe"
export const accountDoesntExist = testAccountCases.getAccountNoMatch;
//name:  iHaveNoLocations
export const accountNoLocations = testAccountCases.accountWithoutLocations;
export const locationDoesntExist = testLocations.noLocationsFound;
// name: ACME
export const accountWithLocations = testAccountCases.accountByNameOrIDWithLocations;
export const locationsBelongingToAccountNoReturns = testLocations.locationThatExists;
export const accountWithLocationsThatHaveReturns = testAccountCases.accountWithChildOrders;
export const locationsWithReturns = testLocations.locationsBelongsTosomeIdWithKids;
export const locationWithOneReturn = testLocations.locationWithReturnsOne;
export const returnByAccountOne = {
    req: {
        url: /WHERE%20Status__c%20=%20%27Returned%20to%20Inventory%27%20AND%20BD2_Inventory__c%20=%20%27RETURN%27%20AND%20\(BD2_Location__c%20=%20%27locationWithReturnsId1%27%20OR%20BD2_Location__c%20=%20%27locationWithReturns%27\)/,
        code: 200,
        body: {
            "totalSize": 2,
            "done": true,
            "records": [
                {
                    "attributes": {
                        "type": "BD2_Return__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Return__c/someRandomId"
                    },
                    "Id": "returnByAccountId1",
                    "Name": "BD2Ret-returnByAccountName1",
                    "Status__c": "Returned to Inventory",
                    "BD2_Inventory__c": "RETURN",
                    "BD2_Location__c": "locationWithReturnsId1",
                    "Reference_Number__c": "refnum",
                    "Testing_Link__c": null,
                    "Test_Results__c": "Passed",
                    "Tracking_Number__c": null,
                    "CreatedDate": "2023-06-02T17:50:28.000+0000"
                },
                {
                    "attributes": {
                        "type": "BD2_Return__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Return__c/someRandomId"
                    },
                    "Id": "returnByAccountId2",
                    "Name": "BD2Ret-returnByAccountName2",
                    "Status__c": "Returned to Inventory",
                    "BD2_Inventory__c": "RETURN",
                    "BD2_Location__c": "locationWithReturnsId1",
                    "Reference_Number__c": "refnum",
                    "Testing_Link__c": null,
                    "Test_Results__c": "Passed",
                    "Tracking_Number__c": null,
                    "CreatedDate": "2023-06-02T17:50:28.000+0000"
                }
            ]
        }
    },
    resp: [
        {
            id: "returnByAccountId1",
            recordName: "BD2Ret-returnByAccountName1",
            fate: "Returned to Inventory",
            inventoryId: "RETURN",
            locationId: "locationWithReturnsId1",
            referenceNumber: "refnum",
            testingLink: null,
            testResults: "Passed",
            returnTrackingNumber: null,
            created: new Date("2023-06-02T17:50:28.000+0000")
        },
        {
            id: "returnByAccountId2",
            recordName: "BD2Ret-returnByAccountName2",
            fate: "Returned to Inventory",
            inventoryId: "RETURN",
            locationId: "locationWithReturnsId1",
            referenceNumber: "refnum",
            testingLink: null,
            testResults: "Passed",
            returnTrackingNumber: null,
            created: new Date("2023-06-02T17:50:28.000+0000")
        },
        {
            id: "returnByAccountId3",
            recordName: "BD2Ret-returnByAccountName3",
            fate: "Returned to Inventory",
            inventoryId: "RETURN",
            locationId: "someLocationId",
            referenceNumber: "refnum",
            testingLink: null,
            testResults: "Passed",
            returnTrackingNumber: null,
            created: new Date("2023-06-02T17:50:28.000+0000")
        }
    ]
};
export const returnByAccountTwo = {
    req: {
        url: /WHERE%20Status__c%20=%20%27Returned%20to%20Inventory%27%20AND%20BD2_Inventory__c%20=%20%27RETURN%27%20AND%20\(BD2_Location__c%20=%20%27locationWithReturnsId2%27%20OR%20BD2_Location__c%20=%20%27locationWithReturns%27\)/,
        code: 200,
        body: {
            "totalSize": 1,
            "done": true,
            "records": [
                {
                    "attributes": {
                        "type": "BD2_Return__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Return__c/someRandomId"
                    },
                    "Id": "returnByAccountId3",
                    "Name": "BD2Ret-returnByAccountName3",
                    "Status__c": "Returned to Inventory",
                    "BD2_Inventory__c": "RETURN",
                    "BD2_Location__c": "someLocationId",
                    "Reference_Number__c": "refnum",
                    "Testing_Link__c": null,
                    "Test_Results__c": "Passed",
                    "Tracking_Number__c": null,
                    "CreatedDate": "2023-06-02T17:50:28.000+0000"
                }
            ]
        }
    }
};
export const returnByLocationFaulty = {
    req: {
        url: /WHERE%20Test_Results__c%20=%20%27Failed%27%20AND%20\(BD2_Location__c%20=%20%27locationWithReturnsId1%27%20OR%20BD2_Location__c%20=%20%27locationWithReturns%27\)/,
        code: 200,
        body: {
            "totalSize": 2,
            "done": true,
            "records": [
                {
                    "attributes": {
                        "type": "BD2_Return__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Return__c/someRandomId"
                    },
                    "Id": "returnId1",
                    "Name": "BDR1",
                    "Status__c": "Stored",
                    "BD2_Inventory__c": null,
                    "BD2_Location__c": "someLocationId",
                    "Reference_Number__c": "refnum",
                    "Testing_Link__c": null,
                    "Test_Results__c": "Failed",
                    "Tracking_Number__c": null,
                    "CreatedDate": "2023-06-02T17:50:28.000+0000"
                },
                {
                    "attributes": {
                        "type": "BD2_Return__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Return__c/someRandomId"
                    },
                    "Id": "returnId2",
                    "Name": "BDR2",
                    "Status__c": "Stored",
                    "BD2_Inventory__c": null,
                    "BD2_Location__c": "someLocationId",
                    "Reference_Number__c": "refnum",
                    "Testing_Link__c": null,
                    "Test_Results__c": "Failed",
                    "Tracking_Number__c": null,
                    "CreatedDate": "2023-06-02T17:50:28.000+0000"
                }
            ]
        }
    },
    resp: [
        {
            id: "returnId1",
            recordName: "BDR1",
            fate: "Stored",
            inventoryId: null,
            locationId: "someLocationId",
            referenceNumber: "refnum",
            testingLink: null,
            testResults: "Failed",
            returnTrackingNumber: null,
            created: new Date("2023-06-02T17:50:28.000+0000")
        },
        {
            id: "returnId2",
            recordName: "BDR2",
            fate: "Stored",
            inventoryId: null,
            locationId: "someLocationId",
            referenceNumber: "refnum",
            testingLink: null,
            testResults: "Failed",
            returnTrackingNumber: null,
            created: new Date("2023-06-02T17:50:28.000+0000")
        }
    ]
};
export const returnById = {
    req: {
        url: /WHERE%20Id%20=%20%27someRandomId%27$|WHERE%20Reference_Number__c%20=%20%27someRandomId%27$/i,
        code: 200,
        body: {
            "totalSize": 1,
            "done": true,
            "records": [
                {
                    "attributes": {
                        "type": "BD2_Return__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Return__c/someRandomId"
                    },
                    "Id": "someRandomId",
                    "Name": "BD2Ret-000003",
                    "Status__c": "Stored",
                    "BD2_Inventory__c": null,
                    "BD2_Location__c": "someLocationId",
                    "Reference_Number__c": "refnum",
                    "Testing_Link__c": null,
                    "Test_Results__c": "Untested",
                    "Tracking_Number__c": null,
                    "CreatedDate": "2023-06-02T17:50:28.000+0000"
                }
            ]
        }
    },
    resp: {
        id: "someRandomId",
        recordName: "BD2Ret-000003",
        fate: "Stored",
        inventoryId: null,
        locationId: "someLocationId",
        referenceNumber: "refnum",
        testingLink: null,
        testResults: "Untested",
        returnTrackingNumber: null,
        created: new Date("2023-06-02T17:50:28.000+0000")
    }
};
export const returnByName = {
    req: {
        url: /WHERE%20Name%20=%20%27BD2Ret-000069%27$/i,
        code: 200,
        body: {
            "totalSize": 1,
            "done": true,
            "records": [
                {
                    "attributes": {
                        "type": "BD2_Return__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Return__c/someRandomId"
                    },
                    "Id": "QQQQQ",
                    "Name": "BD2Ret-000069",
                    "Status__c": "Discarded",
                    "BD2_Inventory__c": null,
                    "BD2_Location__c": "someOtherLocationId",
                    "Reference_Number__c": "12345",
                    "Testing_Link__c": null,
                    "Test_Results__c": "Failed",
                    "Tracking_Number__c": null,
                    "CreatedDate": "2023-07-02T17:50:28.000+0000"
                }
            ]
        }
    },
    resp: {
        id: "QQQQQ",
        recordName: "BD2Ret-000069",
        fate: "Discarded",
        inventoryId: null,
        locationId: "someOtherLocationId",
        referenceNumber: "12345",
        testingLink: null,
        testResults: "Failed",
        returnTrackingNumber: null,
        created: new Date("2023-07-02T17:50:28.000+0000")
    }
};
export const dontExist = {
    req: {
        url: /WHERE%20Reference_Number__c%20=%20%27dontexist%27$|WHERE%20\(BD2_Location__c%20=%20%27ARealIdThatExists%27%20OR%20BD2_Location__c%20=%20%27ARealIdThatExi%27\)$/i,
        code: 200,
        body: {
            "totalSize": 0,
            "done": true,
            "records": []
        }
    }
};
export const notUnique = {
    req: {
        url: /WHERE%20Reference_Number__c%20=%20%27NotUnique%27$/i,
        code: 200,
        body: {
            "totalSize": 9,
            "done": true,
            "records": [1, 2, 3, 4, 5, "cat", "banana", 8, 9]
        }
    }
};
export function checkReturnBody(url, opts) {
    let body = JSON.parse(opts.body);
    let respObj = null;
    if (url.match(/__c\/$/)) {
        switch (body.BD2_Location__c) {
            case "okIcreate":
                respObj = createSuccess;
                break;
            default:
                throw `wtf @ ${util.inspect(body, { depth: null })}`;
        }
    }
    else {
        if (url.match(/aLocationWithReturns/i)) {
            const expectedBody = { "Status__c": "Returned to Inventory", "BD2_Inventory__c": "someMasterInventory", "BD2_Location__c": "okIcreate", "Reference_Number__c": null, "Testing_Link__c": null, "Test_Results__c": "Passed", "Tracking_Number__c": null };
            if (opts.body != JSON.stringify(expectedBody)) {
                throw `Payload was wrong`;
            }
            respObj = createSuccess;
        }
        else {
            throw `asdasdasdasd`;
        }
    }
    return { body: respObj.body, status: respObj.code };
}
const updateOk = {
    code: 204,
    body: null
};
const createSuccess = {
    code: 201,
    body: {
        "id": "aLocationWithReturns!",
        "success": true,
        "errors": []
    }
};
