export declare const noSubsFound: {
    req: {
        url: RegExp;
        code: number;
        body: {
            totalSize: number;
            done: boolean;
            records: never[];
        };
    };
    resp: never[];
};
export declare const badId: {
    req: {
        url: RegExp;
        code: number;
        body: {
            message: string;
            errorCode: string;
            fields: never[];
        }[];
    };
    resp: never[];
};
export declare const created: {
    code: number;
    body: {
        id: string;
        success: boolean;
        errors: never[];
    };
};
export declare const selectSubById: {
    req: {
        url: RegExp;
        code: number;
        body: {
            totalSize: number;
            done: boolean;
            records: {
                attributes: {
                    type: string;
                    url: string;
                };
                Id: string;
                Name: string;
                BD2_Account__c: string;
                Charge_Type__c: string;
                Invoice_To__c: string;
                Invoice_From__c: string;
                Currency__c: string;
                Invoice_Date__c: string;
                Invoice_Number__c: string;
                Manual_Adjustments__c: null;
                Notes__c: null;
                isActive__c: boolean;
                Subscription_Quantity__c: number;
                Subscription_Schedule__c: string;
                Subscription_Type__c: string;
                Invoice_Amount__c: number;
                Shopify_Subscription_ID__c: number;
                Subtotal__c: number;
                Tax__c: number;
                Associated_Order__c: string;
            }[];
        };
    };
    resp: {
        id: string;
        externalId: string;
        accountId: string;
        qty: number;
        schedule: string;
        shopSubId: number;
        subType: string;
        notes: string;
        associatedOrder: string;
        coverage: {
            coverageTo: Date;
            coverageFrom: Date;
            isActive: boolean;
        };
        monies: {
            chargeType: string;
            currency: string;
            invoiceDate: Date;
            invoiceNumber: string;
            priceAdjustment: null;
            totalCharge: number;
            subtotal: number;
            tax: number;
        };
    };
};
export declare const selectSubsBelongingToAccount: {
    req: {
        url: RegExp;
        code: number;
        body: {
            totalSize: number;
            done: boolean;
            records: {
                attributes: {
                    type: string;
                    url: string;
                };
                Id: string;
                Name: string;
                BD2_Account__c: string;
                Charge_Type__c: string;
                Invoice_To__c: string;
                Invoice_From__c: string;
                Currency__c: string;
                Invoice_Date__c: string;
                Invoice_Number__c: string;
                Manual_Adjustments__c: null;
                Notes__c: null;
                isActive__c: boolean;
                Subscription_Quantity__c: number;
                Subscription_Schedule__c: string;
                Subscription_Type__c: string;
                Invoice_Amount__c: number;
                Shopify_Subscription_ID__c: number;
                Subtotal__c: number;
                Tax__c: number;
                Associated_Order__c: null;
            }[];
        };
    };
    resp: {
        id: string;
        externalId: string;
        accountId: string;
        qty: number;
        schedule: string;
        shopSubId: number;
        subType: string;
        notes: string;
        associatedOrder: null;
        coverage: {
            coverageTo: Date;
            coverageFrom: Date;
            isActive: boolean;
        };
        monies: {
            chargeType: string;
            currency: string;
            invoiceDate: Date;
            invoiceNumber: string;
            priceAdjustment: null;
            totalCharge: number;
            subtotal: number;
            tax: number;
        };
    }[];
};
export declare function checkBodyPost(url: string, opts: any): {
    body: {
        message: string;
        errorCode: string;
        fields: never[];
    }[];
    status: number;
} | {
    body: {
        id: string;
        success: boolean;
        errors: never[];
    };
    status: number;
} | undefined;
export declare function checkBodyPatch(url: string, opts: any): {
    body: null;
    status: number;
};
export declare const subsForAcctResp: {
    totalSize: number;
    done: boolean;
    records: {
        attributes: {
            type: string;
            url: string;
        };
        Invoice_Number__c: string;
    }[];
};
