import util from 'util';
export const noSubsFound = {
    req: {
        url: /SubDontExist/,
        code: 200,
        body: {
            "totalSize": 0,
            "done": true,
            "records": []
        }
    },
    resp: []
};
export const badId = {
    req: {
        url: /badAccountId/,
        code: 400,
        body: [
            {
                "message": "invalid cross reference id",
                "errorCode": "INVALID_CROSS_REFERENCE_KEY",
                "fields": []
            }
        ]
    },
    resp: []
};
export const created = {
    code: 201,
    body: {
        "id": "newSubId",
        "success": true,
        "errors": []
    }
};
const updateOk = {
    code: 204,
    body: null
};
export const selectSubById = {
    req: {
        url: /ARealIdThatExists|theNameOfASub/,
        code: 200,
        body: {
            "totalSize": 1,
            "done": true,
            "records": [
                {
                    "attributes": {
                        "type": "BD2_Subscription__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Subscription__c/a0kOL000001DfOBYA0"
                    },
                    "Id": "a0kOL000001DfOBYA0",
                    "Name": "SUB-00000002",
                    "BD2_Account__c": "a0gJA0000000kzfYAA",
                    "Charge_Type__c": "Invoice",
                    "Invoice_To__c": "2024-01-27",
                    "Invoice_From__c": "2024-01-21",
                    "Currency__c": "USD",
                    "Invoice_Date__c": "2024-01-25",
                    "Invoice_Number__c": "123",
                    "Manual_Adjustments__c": null,
                    "Notes__c": null,
                    "isActive__c": true,
                    "Subscription_Quantity__c": 5.0,
                    "Subscription_Schedule__c": "Monthly",
                    "Subscription_Type__c": "Per Scanner",
                    "Invoice_Amount__c": 143.0,
                    "Shopify_Subscription_ID__c": 1359754,
                    "Subtotal__c": 123.0,
                    "Tax__c": 20,
                    "Associated_Order__c": "asdhajsfaf"
                }
            ]
        }
    },
    resp: {
        id: 'a0kOL000001DfOBYA0',
        externalId: 'SUB-00000002',
        accountId: 'a0gJA0000000kzfYAA',
        qty: 5,
        schedule: 'Monthly',
        shopSubId: 1359754,
        subType: 'Per Scanner',
        notes: "",
        associatedOrder: "asdhajsfaf",
        coverage: {
            coverageTo: new Date("2024-01-27"),
            coverageFrom: new Date("2024-01-21"),
            isActive: true
        },
        monies: {
            chargeType: 'Invoice',
            currency: 'USD',
            invoiceDate: new Date("2024-01-25"),
            invoiceNumber: '123',
            priceAdjustment: null,
            totalCharge: 143,
            subtotal: 123,
            tax: 20
        }
    }
};
export const selectSubsBelongingToAccount = {
    req: {
        url: /BD2_Account__c%20=%20%27someRandomIdLookATthis0mg%27%20OR%20BD2_Account__c%20=%20%27someRandomIdLookATthis%27/,
        code: 200,
        body: {
            "totalSize": 2,
            "done": true,
            "records": [
                {
                    "attributes": {
                        "type": "BD2_Subscription__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Subscription__c/a0kOL000001DfOBYA0"
                    },
                    "Id": "a0kOL000001DfOBYA0",
                    "Name": "SUB-00000002",
                    "BD2_Account__c": "a0gJA0000000kzfYAA",
                    "Charge_Type__c": "Invoice",
                    "Invoice_To__c": "2024-01-27",
                    "Invoice_From__c": "2024-01-21",
                    "Currency__c": "USD",
                    "Invoice_Date__c": "2024-01-25",
                    "Invoice_Number__c": "123",
                    "Manual_Adjustments__c": null,
                    "Notes__c": null,
                    "isActive__c": true,
                    "Subscription_Quantity__c": 5.0,
                    "Subscription_Schedule__c": "Monthly",
                    "Subscription_Type__c": "Per Scanner",
                    "Invoice_Amount__c": 143.0,
                    "Shopify_Subscription_ID__c": 1359754,
                    "Subtotal__c": 123.0,
                    "Tax__c": 20,
                    "Associated_Order__c": null
                },
                {
                    "attributes": {
                        "type": "BD2_Subscription__c",
                        "url": "/services/data/v57.0/sobjects/BD2_Subscription__c/a0kOL000001DfOBYA0"
                    },
                    "Id": "asfasdasd",
                    "Name": "SUB-00000003",
                    "BD2_Account__c": "a0gJA0000000kzfYAA",
                    "Charge_Type__c": "Invoice",
                    "Invoice_To__c": "2024-01-27",
                    "Invoice_From__c": "2024-01-21",
                    "Currency__c": "CAD",
                    "Invoice_Date__c": "2024-01-25",
                    "Invoice_Number__c": "123",
                    "Manual_Adjustments__c": null,
                    "Notes__c": null,
                    "isActive__c": true,
                    "Subscription_Quantity__c": 5.0,
                    "Subscription_Schedule__c": "Monthly",
                    "Subscription_Type__c": "Per Roof",
                    "Invoice_Amount__c": 143.0,
                    "Shopify_Subscription_ID__c": 1359754,
                    "Subtotal__c": 123.0,
                    "Tax__c": 20,
                    "Associated_Order__c": null
                }
            ]
        }
    },
    resp: [{
            id: 'a0kOL000001DfOBYA0',
            externalId: 'SUB-00000002',
            accountId: 'a0gJA0000000kzfYAA',
            qty: 5,
            schedule: 'Monthly',
            shopSubId: 1359754,
            subType: 'Per Scanner',
            notes: "",
            associatedOrder: null,
            coverage: {
                coverageTo: new Date("2024-01-27"),
                coverageFrom: new Date("2024-01-21"),
                isActive: true
            },
            monies: {
                chargeType: 'Invoice',
                currency: 'USD',
                invoiceDate: new Date("2024-01-25"),
                invoiceNumber: '123',
                priceAdjustment: null,
                totalCharge: 143,
                subtotal: 123,
                tax: 20
            }
        },
        {
            id: 'asfasdasd',
            externalId: 'SUB-00000003',
            accountId: 'a0gJA0000000kzfYAA',
            qty: 5,
            schedule: 'Monthly',
            shopSubId: 1359754,
            subType: 'Per Roof',
            notes: "",
            associatedOrder: null,
            coverage: {
                coverageTo: new Date("2024-01-27"),
                coverageFrom: new Date("2024-01-21"),
                isActive: true
            },
            monies: {
                chargeType: 'Invoice',
                currency: 'CAD',
                invoiceDate: new Date("2024-01-25"),
                invoiceNumber: '123',
                priceAdjustment: null,
                totalCharge: 143,
                subtotal: 123,
                tax: 20
            }
        }]
};
export function checkBodyPost(url, opts) {
    let body = JSON.parse(opts.body);
    if (body.BD2_Account__c === 'badAccountId') {
        let expectedBody = JSON.stringify({
            "BD2_Account__c": "badAccountId",
            "Subscription_Quantity__c": 123,
            "Subscription_Schedule__c": "Monthly",
            "Subscription_Type__c": "Per Roof",
            "Notes__c": "",
            "Shopify_Subscription_ID__c": "123456",
            "Associated_Order__c": null,
            "Invoice_To__c": "2025-05-21",
            "Invoice_From__c": "1985-05-21",
            "Charge_Type__c": "Invoice",
            "Currency__c": "CAD",
            "Invoice_Date__c": "1985-05-21",
            "Invoice_Number__c": "asdasdsad",
            "Manual_Adjustments__c": 0,
            "Invoice_Amount__c": 123,
            "Subtotal__c": 123,
            "Tax__c": 0
        });
        if (expectedBody !== opts.body) {
            console.log(util.inspect(body, { depth: null }));
            throw new Error("BAD BODY");
        }
        return { body: badId.req.body, status: badId.req.code };
    }
    if (body.BD2_Account__c === 'someRandomIdLookATthis0mg') {
        let expectedBody = JSON.stringify({
            BD2_Account__c: 'someRandomIdLookATthis0mg',
            Subscription_Quantity__c: 5,
            Subscription_Schedule__c: 'Annually',
            Subscription_Type__c: 'Per Scanner',
            Notes__c: 'This is a test!',
            Shopify_Subscription_ID__c: "123456",
            Associated_Order__c: null,
            Invoice_To__c: '2025-05-21',
            Invoice_From__c: '1985-05-21',
            Charge_Type__c: 'Shopify',
            Currency__c: 'USD',
            Invoice_Date__c: '1985-05-21',
            Invoice_Number__c: 'asdasdsad',
            Manual_Adjustments__c: -200000,
            Invoice_Amount__c: 1000000,
            Subtotal__c: 1200000,
            Tax__c: 0
        });
        if (expectedBody !== opts.body) {
            console.log(util.inspect(body, { depth: null }));
            throw new Error("BAD BODY");
        }
        return { body: created.body, status: created.code };
    }
}
export function checkBodyPatch(url, opts) {
    let body = JSON.parse(opts.body);
    if (url.match(/someExistingSub$/)) {
        let expectedBody = JSON.stringify({
            Subscription_Quantity__c: 5,
            Subscription_Schedule__c: 'Annually',
            Subscription_Type__c: 'Per Scanner',
            Notes__c: 'This is a test!',
            Shopify_Subscription_ID__c: "123456",
            Associated_Order__c: null,
            Invoice_To__c: '2025-05-21',
            Invoice_From__c: '1985-05-21',
            Charge_Type__c: 'Shopify',
            Currency__c: 'USD',
            Invoice_Date__c: '1985-05-21',
            Invoice_Number__c: 'asdasdsad',
            Manual_Adjustments__c: 0,
            Invoice_Amount__c: 1200000,
            Subtotal__c: 1200000,
            Tax__c: 0
        });
        if (expectedBody !== opts.body) {
            console.log(util.inspect(body, { depth: null }));
            throw new Error("BAD BODY");
        }
        return { body: updateOk.body, status: updateOk.code };
    }
    throw new Error("ASDJADKAJSKDASSADSD");
}
export const subsForAcctResp = {
    "totalSize": 3,
    "done": true,
    "records": [
        {
            "attributes": {
                "type": "BD2_Subscription__c",
                "url": "/services/data/v57.0/sobjects/BD2_Subscription__c/a0kOL000001RhmfYAC"
            },
            "Invoice_Number__c": "5514445258999"
        },
        {
            "attributes": {
                "type": "BD2_Subscription__c",
                "url": "/services/data/v57.0/sobjects/BD2_Subscription__c/a0kOL000001RhoHYAS"
            },
            "Invoice_Number__c": "5514408591607"
        },
        {
            "attributes": {
                "type": "BD2_Subscription__c",
                "url": "/services/data/v57.0/sobjects/BD2_Subscription__c/a0kOL000001RidtYAC"
            },
            "Invoice_Number__c": "5514609197303"
        }
    ]
};
